
C ========== begin copyright notice ==============
C This file is part of 
C ---------------
C xaifBooster
C ---------------
C Distributed under the BSD license as follows:
C Copyright (c) 2005, The University of Chicago
C All rights reserved.
C
C Redistribution and use in source and binary forms, 
C with or without modification, are permitted provided that the following conditions are met:
C
C    - Redistributions of source code must retain the above copyright notice, 
C      this list of conditions and the following disclaimer.
C    - Redistributions in binary form must reproduce the above copyright notice, 
C      this list of conditions and the following disclaimer in the documentation 
C      and/or other materials provided with the distribution.
C    - Neither the name of The University of Chicago nor the names of its contributors 
C      may be used to endorse or promote products derived from this software without 
C      specific prior written permission.
C
C THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY 
C EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES 
C OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT 
C SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, 
C INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
C PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
C INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT 
C LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
C OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
C 
C General Information:
C xaifBooster is intended for the transformation of 
C numerical programs represented as xml files according 
C to the XAIF schema. It is part of the OpenAD framework. 
C The main application is automatic 
C differentiation, i.e. the generation of code for 
C the computation of derivatives. 
C The following people are the principal authors of the 
C current version: 
C 	Uwe Naumann
C	Jean Utke
C Additional contributors are: 
C	Andrew Lyons
C	Peter Fine
C
C For more details about xaifBooster and its use in OpenAD please visit:
C   http://www.mcs.anl.gov/openad
C
C This work is partially supported by:
C 	NSF-ITR grant OCE-0205590
C ========== end copyright notice ==============

      SUBROUTINE ad_roehf5(NRM, PRIML, PRIMR, GAMMA, GM1, GM1INV,
     >  NLEFIX, LEFIX, MCHEPS, FLUX)
          use OAD_tape
          use OAD_rev

          ! original arguments get inserted before version
          ! and declared here together with all local variables
          ! generated by xaifBooster

      use w2f__types
      use OAD_active
      IMPLICIT NONE
C
C     **** Global Variables & Derived Type Definitions ****
C
      REAL(w2f__8) OpenAD_Symbol_0
      REAL(w2f__8) OpenAD_Symbol_1
      REAL(w2f__8) OpenAD_Symbol_10
      REAL(w2f__8) OpenAD_Symbol_100
      REAL(w2f__8) OpenAD_Symbol_101
      REAL(w2f__8) OpenAD_Symbol_102
      REAL(w2f__8) OpenAD_Symbol_103
      REAL(w2f__8) OpenAD_Symbol_104
      REAL(w2f__8) OpenAD_Symbol_105
      REAL(w2f__8) OpenAD_Symbol_106
      REAL(w2f__8) OpenAD_Symbol_107
      REAL(w2f__8) OpenAD_Symbol_109
      REAL(w2f__8) OpenAD_Symbol_11
      REAL(w2f__8) OpenAD_Symbol_111
      REAL(w2f__8) OpenAD_Symbol_113
      REAL(w2f__8) OpenAD_Symbol_114
      REAL(w2f__8) OpenAD_Symbol_115
      REAL(w2f__8) OpenAD_Symbol_116
      REAL(w2f__8) OpenAD_Symbol_117
      REAL(w2f__8) OpenAD_Symbol_118
      REAL(w2f__8) OpenAD_Symbol_12
      REAL(w2f__8) OpenAD_Symbol_120
      REAL(w2f__8) OpenAD_Symbol_122
      REAL(w2f__8) OpenAD_Symbol_124
      REAL(w2f__8) OpenAD_Symbol_126
      REAL(w2f__8) OpenAD_Symbol_127
      REAL(w2f__8) OpenAD_Symbol_128
      REAL(w2f__8) OpenAD_Symbol_129
      REAL(w2f__8) OpenAD_Symbol_13
      REAL(w2f__8) OpenAD_Symbol_130
      REAL(w2f__8) OpenAD_Symbol_131
      REAL(w2f__8) OpenAD_Symbol_132
      REAL(w2f__8) OpenAD_Symbol_133
      REAL(w2f__8) OpenAD_Symbol_134
      REAL(w2f__8) OpenAD_Symbol_135
      REAL(w2f__8) OpenAD_Symbol_136
      REAL(w2f__8) OpenAD_Symbol_137
      REAL(w2f__8) OpenAD_Symbol_138
      REAL(w2f__8) OpenAD_Symbol_139
      REAL(w2f__8) OpenAD_Symbol_14
      REAL(w2f__8) OpenAD_Symbol_140
      REAL(w2f__8) OpenAD_Symbol_141
      REAL(w2f__8) OpenAD_Symbol_142
      REAL(w2f__8) OpenAD_Symbol_143
      REAL(w2f__8) OpenAD_Symbol_144
      REAL(w2f__8) OpenAD_Symbol_145
      REAL(w2f__8) OpenAD_Symbol_146
      REAL(w2f__8) OpenAD_Symbol_147
      REAL(w2f__8) OpenAD_Symbol_148
      REAL(w2f__8) OpenAD_Symbol_149
      REAL(w2f__8) OpenAD_Symbol_15
      REAL(w2f__8) OpenAD_Symbol_150
      REAL(w2f__8) OpenAD_Symbol_151
      REAL(w2f__8) OpenAD_Symbol_152
      REAL(w2f__8) OpenAD_Symbol_153
      REAL(w2f__8) OpenAD_Symbol_154
      REAL(w2f__8) OpenAD_Symbol_155
      REAL(w2f__8) OpenAD_Symbol_156
      REAL(w2f__8) OpenAD_Symbol_157
      REAL(w2f__8) OpenAD_Symbol_158
      REAL(w2f__8) OpenAD_Symbol_159
      REAL(w2f__8) OpenAD_Symbol_16
      REAL(w2f__8) OpenAD_Symbol_160
      REAL(w2f__8) OpenAD_Symbol_161
      REAL(w2f__8) OpenAD_Symbol_162
      REAL(w2f__8) OpenAD_Symbol_163
      REAL(w2f__8) OpenAD_Symbol_164
      REAL(w2f__8) OpenAD_Symbol_165
      REAL(w2f__8) OpenAD_Symbol_166
      REAL(w2f__8) OpenAD_Symbol_168
      REAL(w2f__8) OpenAD_Symbol_169
      REAL(w2f__8) OpenAD_Symbol_170
      REAL(w2f__8) OpenAD_Symbol_171
      REAL(w2f__8) OpenAD_Symbol_172
      REAL(w2f__8) OpenAD_Symbol_173
      REAL(w2f__8) OpenAD_Symbol_174
      REAL(w2f__8) OpenAD_Symbol_175
      REAL(w2f__8) OpenAD_Symbol_176
      REAL(w2f__8) OpenAD_Symbol_177
      REAL(w2f__8) OpenAD_Symbol_178
      REAL(w2f__8) OpenAD_Symbol_179
      REAL(w2f__8) OpenAD_Symbol_18
      REAL(w2f__8) OpenAD_Symbol_180
      REAL(w2f__8) OpenAD_Symbol_181
      REAL(w2f__8) OpenAD_Symbol_182
      REAL(w2f__8) OpenAD_Symbol_183
      REAL(w2f__8) OpenAD_Symbol_184
      REAL(w2f__8) OpenAD_Symbol_185
      REAL(w2f__8) OpenAD_Symbol_186
      REAL(w2f__8) OpenAD_Symbol_187
      REAL(w2f__8) OpenAD_Symbol_188
      REAL(w2f__8) OpenAD_Symbol_189
      REAL(w2f__8) OpenAD_Symbol_190
      REAL(w2f__8) OpenAD_Symbol_191
      REAL(w2f__8) OpenAD_Symbol_192
      REAL(w2f__8) OpenAD_Symbol_193
      REAL(w2f__8) OpenAD_Symbol_194
      REAL(w2f__8) OpenAD_Symbol_195
      REAL(w2f__8) OpenAD_Symbol_196
      REAL(w2f__8) OpenAD_Symbol_197
      REAL(w2f__8) OpenAD_Symbol_198
      REAL(w2f__8) OpenAD_Symbol_199
      REAL(w2f__8) OpenAD_Symbol_2
      REAL(w2f__8) OpenAD_Symbol_20
      REAL(w2f__8) OpenAD_Symbol_200
      REAL(w2f__8) OpenAD_Symbol_201
      REAL(w2f__8) OpenAD_Symbol_202
      REAL(w2f__8) OpenAD_Symbol_203
      REAL(w2f__8) OpenAD_Symbol_204
      REAL(w2f__8) OpenAD_Symbol_205
      REAL(w2f__8) OpenAD_Symbol_206
      REAL(w2f__8) OpenAD_Symbol_208
      REAL(w2f__8) OpenAD_Symbol_209
      REAL(w2f__8) OpenAD_Symbol_21
      REAL(w2f__8) OpenAD_Symbol_210
      REAL(w2f__8) OpenAD_Symbol_211
      REAL(w2f__8) OpenAD_Symbol_212
      REAL(w2f__8) OpenAD_Symbol_213
      REAL(w2f__8) OpenAD_Symbol_214
      REAL(w2f__8) OpenAD_Symbol_215
      REAL(w2f__8) OpenAD_Symbol_216
      REAL(w2f__8) OpenAD_Symbol_217
      REAL(w2f__8) OpenAD_Symbol_218
      REAL(w2f__8) OpenAD_Symbol_219
      REAL(w2f__8) OpenAD_Symbol_22
      REAL(w2f__8) OpenAD_Symbol_220
      REAL(w2f__8) OpenAD_Symbol_221
      REAL(w2f__8) OpenAD_Symbol_222
      REAL(w2f__8) OpenAD_Symbol_223
      REAL(w2f__8) OpenAD_Symbol_224
      REAL(w2f__8) OpenAD_Symbol_225
      REAL(w2f__8) OpenAD_Symbol_226
      REAL(w2f__8) OpenAD_Symbol_227
      REAL(w2f__8) OpenAD_Symbol_228
      REAL(w2f__8) OpenAD_Symbol_229
      REAL(w2f__8) OpenAD_Symbol_23
      REAL(w2f__8) OpenAD_Symbol_230
      REAL(w2f__8) OpenAD_Symbol_231
      REAL(w2f__8) OpenAD_Symbol_232
      REAL(w2f__8) OpenAD_Symbol_233
      REAL(w2f__8) OpenAD_Symbol_234
      REAL(w2f__8) OpenAD_Symbol_235
      REAL(w2f__8) OpenAD_Symbol_236
      REAL(w2f__8) OpenAD_Symbol_237
      REAL(w2f__8) OpenAD_Symbol_238
      REAL(w2f__8) OpenAD_Symbol_239
      REAL(w2f__8) OpenAD_Symbol_240
      REAL(w2f__8) OpenAD_Symbol_241
      REAL(w2f__8) OpenAD_Symbol_242
      REAL(w2f__8) OpenAD_Symbol_243
      REAL(w2f__8) OpenAD_Symbol_244
      REAL(w2f__8) OpenAD_Symbol_245
      REAL(w2f__8) OpenAD_Symbol_246
      REAL(w2f__8) OpenAD_Symbol_247
      REAL(w2f__8) OpenAD_Symbol_248
      REAL(w2f__8) OpenAD_Symbol_249
      REAL(w2f__8) OpenAD_Symbol_25
      REAL(w2f__8) OpenAD_Symbol_250
      REAL(w2f__8) OpenAD_Symbol_251
      REAL(w2f__8) OpenAD_Symbol_252
      REAL(w2f__8) OpenAD_Symbol_253
      REAL(w2f__8) OpenAD_Symbol_254
      REAL(w2f__8) OpenAD_Symbol_255
      REAL(w2f__8) OpenAD_Symbol_256
      REAL(w2f__8) OpenAD_Symbol_257
      REAL(w2f__8) OpenAD_Symbol_258
      REAL(w2f__8) OpenAD_Symbol_259
      REAL(w2f__8) OpenAD_Symbol_260
      REAL(w2f__8) OpenAD_Symbol_261
      REAL(w2f__8) OpenAD_Symbol_262
      REAL(w2f__8) OpenAD_Symbol_263
      REAL(w2f__8) OpenAD_Symbol_264
      REAL(w2f__8) OpenAD_Symbol_265
      REAL(w2f__8) OpenAD_Symbol_266
      REAL(w2f__8) OpenAD_Symbol_267
      REAL(w2f__8) OpenAD_Symbol_268
      REAL(w2f__8) OpenAD_Symbol_269
      REAL(w2f__8) OpenAD_Symbol_27
      REAL(w2f__8) OpenAD_Symbol_270
      REAL(w2f__8) OpenAD_Symbol_271
      REAL(w2f__8) OpenAD_Symbol_272
      REAL(w2f__8) OpenAD_Symbol_273
      REAL(w2f__8) OpenAD_Symbol_274
      REAL(w2f__8) OpenAD_Symbol_275
      REAL(w2f__8) OpenAD_Symbol_276
      REAL(w2f__8) OpenAD_Symbol_277
      REAL(w2f__8) OpenAD_Symbol_278
      REAL(w2f__8) OpenAD_Symbol_279
      REAL(w2f__8) OpenAD_Symbol_280
      REAL(w2f__8) OpenAD_Symbol_281
      REAL(w2f__8) OpenAD_Symbol_282
      REAL(w2f__8) OpenAD_Symbol_283
      REAL(w2f__8) OpenAD_Symbol_284
      REAL(w2f__8) OpenAD_Symbol_285
      REAL(w2f__8) OpenAD_Symbol_286
      REAL(w2f__8) OpenAD_Symbol_287
      REAL(w2f__8) OpenAD_Symbol_288
      REAL(w2f__8) OpenAD_Symbol_289
      REAL(w2f__8) OpenAD_Symbol_29
      REAL(w2f__8) OpenAD_Symbol_290
      REAL(w2f__8) OpenAD_Symbol_291
      REAL(w2f__8) OpenAD_Symbol_292
      REAL(w2f__8) OpenAD_Symbol_293
      REAL(w2f__8) OpenAD_Symbol_294
      REAL(w2f__8) OpenAD_Symbol_295
      REAL(w2f__8) OpenAD_Symbol_296
      REAL(w2f__8) OpenAD_Symbol_297
      REAL(w2f__8) OpenAD_Symbol_298
      REAL(w2f__8) OpenAD_Symbol_299
      REAL(w2f__8) OpenAD_Symbol_300
      REAL(w2f__8) OpenAD_Symbol_301
      REAL(w2f__8) OpenAD_Symbol_302
      REAL(w2f__8) OpenAD_Symbol_303
      REAL(w2f__8) OpenAD_Symbol_304
      REAL(w2f__8) OpenAD_Symbol_305
      REAL(w2f__8) OpenAD_Symbol_306
      REAL(w2f__8) OpenAD_Symbol_307
      REAL(w2f__8) OpenAD_Symbol_308
      REAL(w2f__8) OpenAD_Symbol_309
      REAL(w2f__8) OpenAD_Symbol_31
      REAL(w2f__8) OpenAD_Symbol_310
      REAL(w2f__8) OpenAD_Symbol_311
      REAL(w2f__8) OpenAD_Symbol_312
      REAL(w2f__8) OpenAD_Symbol_313
      REAL(w2f__8) OpenAD_Symbol_315
      REAL(w2f__8) OpenAD_Symbol_316
      REAL(w2f__8) OpenAD_Symbol_317
      REAL(w2f__8) OpenAD_Symbol_318
      REAL(w2f__8) OpenAD_Symbol_320
      REAL(w2f__8) OpenAD_Symbol_321
      REAL(w2f__8) OpenAD_Symbol_322
      REAL(w2f__8) OpenAD_Symbol_323
      REAL(w2f__8) OpenAD_Symbol_325
      REAL(w2f__8) OpenAD_Symbol_326
      REAL(w2f__8) OpenAD_Symbol_327
      REAL(w2f__8) OpenAD_Symbol_328
      REAL(w2f__8) OpenAD_Symbol_329
      REAL(w2f__8) OpenAD_Symbol_33
      REAL(w2f__8) OpenAD_Symbol_330
      REAL(w2f__8) OpenAD_Symbol_331
      REAL(w2f__8) OpenAD_Symbol_332
      REAL(w2f__8) OpenAD_Symbol_333
      REAL(w2f__8) OpenAD_Symbol_334
      REAL(w2f__8) OpenAD_Symbol_335
      REAL(w2f__8) OpenAD_Symbol_336
      REAL(w2f__8) OpenAD_Symbol_337
      REAL(w2f__8) OpenAD_Symbol_338
      REAL(w2f__8) OpenAD_Symbol_339
      REAL(w2f__8) OpenAD_Symbol_340
      REAL(w2f__8) OpenAD_Symbol_341
      REAL(w2f__8) OpenAD_Symbol_342
      REAL(w2f__8) OpenAD_Symbol_343
      REAL(w2f__8) OpenAD_Symbol_344
      type(active) :: OpenAD_Symbol_345
      type(active) :: OpenAD_Symbol_346
      type(active) :: OpenAD_Symbol_347
      type(active) :: OpenAD_Symbol_348
      REAL(w2f__8) OpenAD_Symbol_349
      REAL(w2f__8) OpenAD_Symbol_35
      REAL(w2f__8) OpenAD_Symbol_350
      REAL(w2f__8) OpenAD_Symbol_351
      REAL(w2f__8) OpenAD_Symbol_352
      REAL(w2f__8) OpenAD_Symbol_353
      REAL(w2f__8) OpenAD_Symbol_354
      REAL(w2f__8) OpenAD_Symbol_355
      REAL(w2f__8) OpenAD_Symbol_356
      type(active) :: OpenAD_Symbol_357
      type(active) :: OpenAD_Symbol_358
      REAL(w2f__8) OpenAD_Symbol_359
      REAL(w2f__8) OpenAD_Symbol_360
      REAL(w2f__8) OpenAD_Symbol_361
      type(active) :: OpenAD_Symbol_362
      REAL(w2f__8) OpenAD_Symbol_363
      REAL(w2f__8) OpenAD_Symbol_364
      REAL(w2f__8) OpenAD_Symbol_365
      REAL(w2f__8) OpenAD_Symbol_366
      REAL(w2f__8) OpenAD_Symbol_367
      REAL(w2f__8) OpenAD_Symbol_368
      REAL(w2f__8) OpenAD_Symbol_369
      REAL(w2f__8) OpenAD_Symbol_37
      REAL(w2f__8) OpenAD_Symbol_370
      REAL(w2f__8) OpenAD_Symbol_371
      REAL(w2f__8) OpenAD_Symbol_372
      REAL(w2f__8) OpenAD_Symbol_373
      REAL(w2f__8) OpenAD_Symbol_374
      REAL(w2f__8) OpenAD_Symbol_375
      REAL(w2f__8) OpenAD_Symbol_376
      REAL(w2f__8) OpenAD_Symbol_377
      REAL(w2f__8) OpenAD_Symbol_378
      REAL(w2f__8) OpenAD_Symbol_379
      REAL(w2f__8) OpenAD_Symbol_380
      REAL(w2f__8) OpenAD_Symbol_381
      type(active) :: OpenAD_Symbol_382
      type(active) :: OpenAD_Symbol_383
      type(active) :: OpenAD_Symbol_384
      type(active) :: OpenAD_Symbol_385
      type(active) :: OpenAD_Symbol_386
      type(active) :: OpenAD_Symbol_387
      type(active) :: OpenAD_Symbol_388
      type(active) :: OpenAD_Symbol_389
      REAL(w2f__8) OpenAD_Symbol_39
      type(active) :: OpenAD_Symbol_390
      type(active) :: OpenAD_Symbol_391
      type(active) :: OpenAD_Symbol_392
      type(active) :: OpenAD_Symbol_393
      REAL(w2f__8) OpenAD_Symbol_394
      REAL(w2f__8) OpenAD_Symbol_395
      REAL(w2f__8) OpenAD_Symbol_396
      REAL(w2f__8) OpenAD_Symbol_397
      REAL(w2f__8) OpenAD_Symbol_398
      REAL(w2f__8) OpenAD_Symbol_399
      REAL(w2f__8) OpenAD_Symbol_4
      REAL(w2f__8) OpenAD_Symbol_400
      REAL(w2f__8) OpenAD_Symbol_401
      REAL(w2f__8) OpenAD_Symbol_402
      REAL(w2f__8) OpenAD_Symbol_403
      REAL(w2f__8) OpenAD_Symbol_404
      REAL(w2f__8) OpenAD_Symbol_405
      REAL(w2f__8) OpenAD_Symbol_406
      REAL(w2f__8) OpenAD_Symbol_407
      REAL(w2f__8) OpenAD_Symbol_408
      REAL(w2f__8) OpenAD_Symbol_409
      REAL(w2f__8) OpenAD_Symbol_41
      REAL(w2f__8) OpenAD_Symbol_410
      REAL(w2f__8) OpenAD_Symbol_411
      REAL(w2f__8) OpenAD_Symbol_412
      REAL(w2f__8) OpenAD_Symbol_413
      REAL(w2f__8) OpenAD_Symbol_414
      REAL(w2f__8) OpenAD_Symbol_415
      REAL(w2f__8) OpenAD_Symbol_416
      REAL(w2f__8) OpenAD_Symbol_417
      REAL(w2f__8) OpenAD_Symbol_418
      REAL(w2f__8) OpenAD_Symbol_419
      REAL(w2f__8) OpenAD_Symbol_42
      REAL(w2f__8) OpenAD_Symbol_420
      REAL(w2f__8) OpenAD_Symbol_421
      type(active) :: OpenAD_Symbol_422
      type(active) :: OpenAD_Symbol_423
      type(active) :: OpenAD_Symbol_424
      type(active) :: OpenAD_Symbol_425
      type(active) :: OpenAD_Symbol_426
      type(active) :: OpenAD_Symbol_427
      type(active) :: OpenAD_Symbol_428
      type(active) :: OpenAD_Symbol_429
      REAL(w2f__8) OpenAD_Symbol_43
      type(active) :: OpenAD_Symbol_430
      type(active) :: OpenAD_Symbol_431
      REAL(w2f__8) OpenAD_Symbol_432
      type(active) :: OpenAD_Symbol_433
      REAL(w2f__8) OpenAD_Symbol_434
      type(active) :: OpenAD_Symbol_435
      REAL(w2f__8) OpenAD_Symbol_436
      type(active) :: OpenAD_Symbol_437
      INTEGER(w2f__i8) OpenAD_Symbol_438
      INTEGER(w2f__i8) OpenAD_Symbol_439
      REAL(w2f__8) OpenAD_Symbol_44
      INTEGER(w2f__i8) OpenAD_Symbol_440
      INTEGER(w2f__i8) OpenAD_Symbol_441
      INTEGER(w2f__i8) OpenAD_Symbol_442
      INTEGER(w2f__i8) OpenAD_Symbol_443
      INTEGER(w2f__i8) OpenAD_Symbol_444
      INTEGER(w2f__i8) OpenAD_Symbol_445
      INTEGER(w2f__i8) OpenAD_Symbol_446
      INTEGER(w2f__i8) OpenAD_Symbol_447
      INTEGER(w2f__i8) OpenAD_Symbol_448
      INTEGER(w2f__i8) OpenAD_Symbol_449
      REAL(w2f__8) OpenAD_Symbol_45
      INTEGER(w2f__i8) OpenAD_Symbol_450
      INTEGER(w2f__i8) OpenAD_Symbol_451
      INTEGER(w2f__i8) OpenAD_Symbol_452
      INTEGER(w2f__i8) OpenAD_Symbol_453
      INTEGER(w2f__i8) OpenAD_Symbol_454
      INTEGER(w2f__i8) OpenAD_Symbol_455
      INTEGER(w2f__i8) OpenAD_Symbol_456
      INTEGER(w2f__i8) OpenAD_Symbol_457
      INTEGER(w2f__i8) OpenAD_Symbol_458
      INTEGER(w2f__i8) OpenAD_Symbol_459
      REAL(w2f__8) OpenAD_Symbol_46
      INTEGER(w2f__i8) OpenAD_Symbol_460
      INTEGER(w2f__i8) OpenAD_Symbol_461
      REAL(w2f__8) OpenAD_Symbol_47
      REAL(w2f__8) OpenAD_Symbol_48
      REAL(w2f__8) OpenAD_Symbol_49
      REAL(w2f__8) OpenAD_Symbol_50
      REAL(w2f__8) OpenAD_Symbol_51
      REAL(w2f__8) OpenAD_Symbol_52
      REAL(w2f__8) OpenAD_Symbol_53
      REAL(w2f__8) OpenAD_Symbol_54
      REAL(w2f__8) OpenAD_Symbol_55
      REAL(w2f__8) OpenAD_Symbol_56
      REAL(w2f__8) OpenAD_Symbol_57
      REAL(w2f__8) OpenAD_Symbol_58
      REAL(w2f__8) OpenAD_Symbol_59
      REAL(w2f__8) OpenAD_Symbol_6
      REAL(w2f__8) OpenAD_Symbol_60
      REAL(w2f__8) OpenAD_Symbol_61
      REAL(w2f__8) OpenAD_Symbol_62
      REAL(w2f__8) OpenAD_Symbol_63
      REAL(w2f__8) OpenAD_Symbol_64
      REAL(w2f__8) OpenAD_Symbol_65
      REAL(w2f__8) OpenAD_Symbol_66
      REAL(w2f__8) OpenAD_Symbol_67
      REAL(w2f__8) OpenAD_Symbol_68
      REAL(w2f__8) OpenAD_Symbol_69
      REAL(w2f__8) OpenAD_Symbol_70
      REAL(w2f__8) OpenAD_Symbol_71
      REAL(w2f__8) OpenAD_Symbol_72
      REAL(w2f__8) OpenAD_Symbol_73
      REAL(w2f__8) OpenAD_Symbol_75
      REAL(w2f__8) OpenAD_Symbol_77
      REAL(w2f__8) OpenAD_Symbol_79
      REAL(w2f__8) OpenAD_Symbol_81
      REAL(w2f__8) OpenAD_Symbol_82
      REAL(w2f__8) OpenAD_Symbol_83
      REAL(w2f__8) OpenAD_Symbol_84
      REAL(w2f__8) OpenAD_Symbol_85
      REAL(w2f__8) OpenAD_Symbol_86
      REAL(w2f__8) OpenAD_Symbol_87
      REAL(w2f__8) OpenAD_Symbol_88
      REAL(w2f__8) OpenAD_Symbol_89
      REAL(w2f__8) OpenAD_Symbol_9
      REAL(w2f__8) OpenAD_Symbol_90
      REAL(w2f__8) OpenAD_Symbol_91
      REAL(w2f__8) OpenAD_Symbol_92
      REAL(w2f__8) OpenAD_Symbol_93
      REAL(w2f__8) OpenAD_Symbol_94
      REAL(w2f__8) OpenAD_Symbol_95
      REAL(w2f__8) OpenAD_Symbol_96
      REAL(w2f__8) OpenAD_Symbol_97
      REAL(w2f__8) OpenAD_Symbol_98
      REAL(w2f__8) OpenAD_Symbol_99
C
C     **** Parameters and Result ****
C
      type(active) :: NRM(1:3)
      type(active) :: PRIML(1:5)
      type(active) :: PRIMR(1:5)
      type(active) :: GAMMA
      type(active) :: GM1
      type(active) :: GM1INV
      type(active) :: NLEFIX
      type(active) :: LEFIX
      REAL(w2f__8) MCHEPS
      INTENT(IN)  MCHEPS
      type(active) :: FLUX(1:5)
C
C     **** Local Variables and Functions ****
C
      type(active) :: ALAMCM
      type(active) :: ALAMCP
      type(active) :: ALAMU
      type(active) :: ALP1
      type(active) :: ALP15M
      type(active) :: ALP15P
      type(active) :: ALP2
      type(active) :: ALP3
      type(active) :: ALP4
      type(active) :: ALP5
      type(active) :: CAVE
      type(active) :: DE
      type(active) :: DELTA
      type(active) :: DELTA2
      type(active) :: DR
      type(active) :: DRU
      type(active) :: DRV
      type(active) :: DRW
      type(active) :: DSS1
      type(active) :: DSS2
      type(active) :: DSS3
      type(active) :: DSS4
      type(active) :: DSS5
      type(active) :: EL
      type(active) :: ER
      REAL(w2f__4) HALF
      PARAMETER ( HALF = 5.0E-01)
      type(active) :: HAVE
      type(active) :: HL
      type(active) :: HR
      type(active) :: LAM2
      type(active) :: LAMCM
      type(active) :: LAMCP
      type(active) :: LAMU
      type(active) :: MU
      type(active) :: NDDRU
      type(active) :: NSIZE
      type(active) :: NSIZEI
      type(active) :: NXHAT
      type(active) :: NYHAT
      type(active) :: NZHAT
      type(active) :: OMEGA
      REAL(w2f__4) ONE
      PARAMETER ( ONE = 1.0)
      type(active) :: ROEL
      type(active) :: ROER
      type(active) :: RUL
      type(active) :: RUR
      type(active) :: RVL
      type(active) :: RVR
      type(active) :: RWL
      type(active) :: RWR
      type(active) :: THETAL
      type(active) :: THETAR
      type(active) :: THTAVE
      type(active) :: UAVE
      type(active) :: UDDRU
      type(active) :: UHAT
      type(active) :: UHATL
      type(active) :: UTILDE
      type(active) :: VAVE
      type(active) :: VTILDE
      type(active) :: WAVE
      type(active) :: WTILDE
      REAL(w2f__4) ZERO
      PARAMETER ( ZERO = 0.0)
      REAL(w2f__8) OpenAD_Symbol_462
      REAL(w2f__8) OpenAD_Symbol_463
      REAL(w2f__8) OpenAD_Symbol_464
      REAL(w2f__8) OpenAD_Symbol_465
      REAL(w2f__8) OpenAD_Symbol_466
      REAL(w2f__8) OpenAD_Symbol_467
      REAL(w2f__8) OpenAD_Symbol_468
      REAL(w2f__8) OpenAD_Symbol_469
      REAL(w2f__8) OpenAD_Symbol_470
      REAL(w2f__8) OpenAD_Symbol_471
      REAL(w2f__8) OpenAD_Symbol_472
      REAL(w2f__8) OpenAD_Symbol_473
      REAL(w2f__8) OpenAD_Symbol_474
      REAL(w2f__8) OpenAD_Symbol_475
      REAL(w2f__8) OpenAD_Symbol_476
      REAL(w2f__8) OpenAD_Symbol_477
      REAL(w2f__8) OpenAD_Symbol_478
      REAL(w2f__8) OpenAD_Symbol_479
      REAL(w2f__8) OpenAD_Symbol_480
      REAL(w2f__8) OpenAD_Symbol_481
      REAL(w2f__8) OpenAD_Symbol_482
      REAL(w2f__8) OpenAD_Symbol_483
      REAL(w2f__8) OpenAD_Symbol_484
      REAL(w2f__8) OpenAD_Symbol_485
      REAL(w2f__8) OpenAD_Symbol_486
      REAL(w2f__8) OpenAD_Symbol_487
      REAL(w2f__8) OpenAD_Symbol_488
      REAL(w2f__8) OpenAD_Symbol_489
      REAL(w2f__8) OpenAD_Symbol_490
      REAL(w2f__8) OpenAD_Symbol_491
      REAL(w2f__8) OpenAD_Symbol_492
      REAL(w2f__8) OpenAD_Symbol_493
      REAL(w2f__8) OpenAD_Symbol_494
      REAL(w2f__8) OpenAD_Symbol_495
      REAL(w2f__8) OpenAD_Symbol_496
      REAL(w2f__8) OpenAD_Symbol_497
      REAL(w2f__8) OpenAD_Symbol_498
      REAL(w2f__8) OpenAD_Symbol_499
      REAL(w2f__8) OpenAD_Symbol_500
      REAL(w2f__8) OpenAD_Symbol_501
      REAL(w2f__8) OpenAD_Symbol_502
      REAL(w2f__8) OpenAD_Symbol_503
      REAL(w2f__8) OpenAD_Symbol_504
      REAL(w2f__8) OpenAD_Symbol_505
      REAL(w2f__8) OpenAD_Symbol_506
      REAL(w2f__8) OpenAD_Symbol_507
      REAL(w2f__8) OpenAD_Symbol_508
      REAL(w2f__8) OpenAD_Symbol_509
      REAL(w2f__8) OpenAD_Symbol_510
      REAL(w2f__8) OpenAD_Symbol_511
      REAL(w2f__8) OpenAD_Symbol_512
      REAL(w2f__8) OpenAD_Symbol_513
      REAL(w2f__8) OpenAD_Symbol_514
      REAL(w2f__8) OpenAD_Symbol_515
      REAL(w2f__8) OpenAD_Symbol_516
      REAL(w2f__8) OpenAD_Symbol_517
      REAL(w2f__8) OpenAD_Symbol_518
      REAL(w2f__8) OpenAD_Symbol_519
      REAL(w2f__8) OpenAD_Symbol_520
      REAL(w2f__8) OpenAD_Symbol_521
      REAL(w2f__8) OpenAD_Symbol_522
      REAL(w2f__8) OpenAD_Symbol_523
      REAL(w2f__8) OpenAD_Symbol_524
      REAL(w2f__8) OpenAD_Symbol_525
      REAL(w2f__8) OpenAD_Symbol_526
      REAL(w2f__8) OpenAD_Symbol_527
      REAL(w2f__8) OpenAD_Symbol_528
      REAL(w2f__8) OpenAD_Symbol_529
      REAL(w2f__8) OpenAD_Symbol_530
      REAL(w2f__8) OpenAD_Symbol_531
      REAL(w2f__8) OpenAD_Symbol_532
      REAL(w2f__8) OpenAD_Symbol_533
      REAL(w2f__8) OpenAD_Symbol_534
      REAL(w2f__8) OpenAD_Symbol_535
      REAL(w2f__8) OpenAD_Symbol_536
      REAL(w2f__8) OpenAD_Symbol_537
      REAL(w2f__8) OpenAD_Symbol_538
      REAL(w2f__8) OpenAD_Symbol_539
      REAL(w2f__8) OpenAD_Symbol_540
      REAL(w2f__8) OpenAD_Symbol_541
      REAL(w2f__8) OpenAD_Symbol_542
      REAL(w2f__8) OpenAD_Symbol_543
      REAL(w2f__8) OpenAD_Symbol_544
      REAL(w2f__8) OpenAD_Symbol_545
      REAL(w2f__8) OpenAD_Symbol_546
      REAL(w2f__8) OpenAD_Symbol_547
      REAL(w2f__8) OpenAD_Symbol_548
      REAL(w2f__8) OpenAD_Symbol_549
      REAL(w2f__8) OpenAD_Symbol_550
      REAL(w2f__8) OpenAD_Symbol_551
      REAL(w2f__8) OpenAD_Symbol_552
      REAL(w2f__8) OpenAD_Symbol_553
      REAL(w2f__8) OpenAD_Symbol_554
      REAL(w2f__8) OpenAD_Symbol_555
      REAL(w2f__8) OpenAD_Symbol_556
      REAL(w2f__8) OpenAD_Symbol_557
      REAL(w2f__8) OpenAD_Symbol_558
      REAL(w2f__8) OpenAD_Symbol_559
      REAL(w2f__8) OpenAD_Symbol_560
      REAL(w2f__8) OpenAD_Symbol_561
      REAL(w2f__8) OpenAD_Symbol_562
      REAL(w2f__8) OpenAD_Symbol_563
      REAL(w2f__8) OpenAD_Symbol_564
      REAL(w2f__8) OpenAD_Symbol_565
      REAL(w2f__8) OpenAD_Symbol_566
      REAL(w2f__8) OpenAD_Symbol_567
      REAL(w2f__8) OpenAD_Symbol_568
      REAL(w2f__8) OpenAD_Symbol_569
      REAL(w2f__8) OpenAD_Symbol_570
      REAL(w2f__8) OpenAD_Symbol_571
      REAL(w2f__8) OpenAD_Symbol_572
      REAL(w2f__8) OpenAD_Symbol_573
      REAL(w2f__8) OpenAD_Symbol_574
      REAL(w2f__8) OpenAD_Symbol_575
      REAL(w2f__8) OpenAD_Symbol_576
      REAL(w2f__8) OpenAD_Symbol_577
      REAL(w2f__8) OpenAD_Symbol_578
      REAL(w2f__8) OpenAD_Symbol_579
      REAL(w2f__8) OpenAD_Symbol_580
      REAL(w2f__8) OpenAD_Symbol_581
      REAL(w2f__8) OpenAD_Symbol_582
      REAL(w2f__8) OpenAD_Symbol_583
      REAL(w2f__8) OpenAD_Symbol_584
      REAL(w2f__8) OpenAD_Symbol_585
      REAL(w2f__8) OpenAD_Symbol_586
      REAL(w2f__8) OpenAD_Symbol_587
      REAL(w2f__8) OpenAD_Symbol_588
      REAL(w2f__8) OpenAD_Symbol_589
      REAL(w2f__8) OpenAD_Symbol_590
      REAL(w2f__8) OpenAD_Symbol_591
      REAL(w2f__8) OpenAD_Symbol_592
      REAL(w2f__8) OpenAD_Symbol_593
      REAL(w2f__8) OpenAD_Symbol_594
      REAL(w2f__8) OpenAD_Symbol_595
      REAL(w2f__8) OpenAD_Symbol_596
      REAL(w2f__8) OpenAD_Symbol_597
      REAL(w2f__8) OpenAD_Symbol_598
      REAL(w2f__8) OpenAD_Symbol_599
      REAL(w2f__8) OpenAD_Symbol_600
      REAL(w2f__8) OpenAD_Symbol_601
      REAL(w2f__8) OpenAD_Symbol_602
      REAL(w2f__8) OpenAD_Symbol_603
      REAL(w2f__8) OpenAD_Symbol_604
      REAL(w2f__8) OpenAD_Symbol_605
      REAL(w2f__8) OpenAD_Symbol_606
      REAL(w2f__8) OpenAD_Symbol_607
      REAL(w2f__8) OpenAD_Symbol_608
      REAL(w2f__8) OpenAD_Symbol_609
      REAL(w2f__8) OpenAD_Symbol_610
      REAL(w2f__8) OpenAD_Symbol_611
      REAL(w2f__8) OpenAD_Symbol_612
      REAL(w2f__8) OpenAD_Symbol_613
      REAL(w2f__8) OpenAD_Symbol_614
      REAL(w2f__8) OpenAD_Symbol_615
      REAL(w2f__8) OpenAD_Symbol_616
      REAL(w2f__8) OpenAD_Symbol_617
      REAL(w2f__8) OpenAD_Symbol_618
      REAL(w2f__8) OpenAD_Symbol_619
      REAL(w2f__8) OpenAD_Symbol_620
      REAL(w2f__8) OpenAD_Symbol_621
      REAL(w2f__8) OpenAD_Symbol_622
      REAL(w2f__8) OpenAD_Symbol_623
      REAL(w2f__8) OpenAD_Symbol_624
      REAL(w2f__8) OpenAD_Symbol_625
      REAL(w2f__8) OpenAD_Symbol_626
      REAL(w2f__8) OpenAD_Symbol_627
      REAL(w2f__8) OpenAD_Symbol_628
      REAL(w2f__8) OpenAD_Symbol_629
      REAL(w2f__8) OpenAD_Symbol_630
      REAL(w2f__8) OpenAD_Symbol_631
      REAL(w2f__8) OpenAD_Symbol_632
      REAL(w2f__8) OpenAD_Symbol_633
      REAL(w2f__8) OpenAD_Symbol_634
      REAL(w2f__8) OpenAD_Symbol_635
      REAL(w2f__8) OpenAD_Symbol_636
      REAL(w2f__8) OpenAD_Symbol_637
      REAL(w2f__8) OpenAD_Symbol_638
      REAL(w2f__8) OpenAD_Symbol_639
      REAL(w2f__8) OpenAD_Symbol_640
      REAL(w2f__8) OpenAD_Symbol_641
      REAL(w2f__8) OpenAD_Symbol_642
      REAL(w2f__8) OpenAD_Symbol_643
      REAL(w2f__8) OpenAD_Symbol_644
      REAL(w2f__8) OpenAD_Symbol_645
      REAL(w2f__8) OpenAD_Symbol_646
      REAL(w2f__8) OpenAD_Symbol_647
      REAL(w2f__8) OpenAD_Symbol_648
      REAL(w2f__8) OpenAD_Symbol_649
      REAL(w2f__8) OpenAD_Symbol_650
      REAL(w2f__8) OpenAD_Symbol_651
      REAL(w2f__8) OpenAD_Symbol_652
      REAL(w2f__8) OpenAD_Symbol_653
      REAL(w2f__8) OpenAD_Symbol_654
      REAL(w2f__8) OpenAD_Symbol_655
      REAL(w2f__8) OpenAD_Symbol_656
      REAL(w2f__8) OpenAD_Symbol_657
      REAL(w2f__8) OpenAD_Symbol_658
      REAL(w2f__8) OpenAD_Symbol_659
      REAL(w2f__8) OpenAD_Symbol_660
      REAL(w2f__8) OpenAD_Symbol_661
      REAL(w2f__8) OpenAD_Symbol_662
      REAL(w2f__8) OpenAD_Symbol_663
      REAL(w2f__8) OpenAD_Symbol_664
      REAL(w2f__8) OpenAD_Symbol_665
      REAL(w2f__8) OpenAD_Symbol_666
      REAL(w2f__8) OpenAD_Symbol_667
      REAL(w2f__8) OpenAD_Symbol_668
      REAL(w2f__8) OpenAD_Symbol_669
      REAL(w2f__8) OpenAD_Symbol_670
      REAL(w2f__8) OpenAD_Symbol_671
      REAL(w2f__8) OpenAD_Symbol_672
      REAL(w2f__8) OpenAD_Symbol_673
      REAL(w2f__8) OpenAD_Symbol_674
      REAL(w2f__8) OpenAD_Symbol_675
      REAL(w2f__8) OpenAD_Symbol_676
      REAL(w2f__8) OpenAD_Symbol_677
      REAL(w2f__8) OpenAD_Symbol_678
      REAL(w2f__8) OpenAD_Symbol_679
      REAL(w2f__8) OpenAD_Symbol_680
      REAL(w2f__8) OpenAD_Symbol_681
      REAL(w2f__8) OpenAD_Symbol_682
      REAL(w2f__8) OpenAD_Symbol_683
      REAL(w2f__8) OpenAD_Symbol_684
      REAL(w2f__8) OpenAD_Symbol_685
      REAL(w2f__8) OpenAD_Symbol_686
      REAL(w2f__8) OpenAD_Symbol_687
      REAL(w2f__8) OpenAD_Symbol_688
      REAL(w2f__8) OpenAD_Symbol_689
      REAL(w2f__8) OpenAD_Symbol_690
      REAL(w2f__8) OpenAD_Symbol_691
      REAL(w2f__8) OpenAD_Symbol_692
      REAL(w2f__8) OpenAD_Symbol_693
C
C     **** Top Level Pragmas ****
C
C$OPENAD INDEPENDENT(NRM)
C$OPENAD INDEPENDENT(PRIML)
C$OPENAD INDEPENDENT(PRIMR)
C$OPENAD INDEPENDENT(GAMMA)
C$OPENAD INDEPENDENT(GM1)
C$OPENAD INDEPENDENT(GM1INV)
C$OPENAD INDEPENDENT(NLEFIX)
C$OPENAD INDEPENDENT(LEFIX)
C$OPENAD INDEPENDENT(MCHEPS)
C$OPENAD DEPENDENT(FLUX)
C
C     **** Statements ****
C


          integer iaddr
          external iaddr
C$OPENAD XXX Template ad_template.f

         if (our_rev_mode%plain) then
! original function
      NSIZE%v = SIN((NRM(1)%v**2)+(NRM(2)%v**2)+(NRM(3)%v**2))
      IF (MCHEPS.LT.NSIZE%v) THEN
        NSIZEI%v = (1.0D00/NSIZE%v)
      ELSE
        NSIZEI%v = 0.0D00
      ENDIF
      NXHAT%v = (NRM(1)%v*NSIZEI%v)
      NYHAT%v = (NRM(2)%v*NSIZEI%v)
      NZHAT%v = (NRM(3)%v*NSIZEI%v)
      ROEL%v = (1.0D00/(SIN(PRIMR(2)%v/PRIML(2)%v)+1.0D00))
      ROER%v = (1.0D00-ROEL%v)
      THETAL%v = (((PRIML(3)%v**2)+(PRIML(4)%v**2)+(PRIML(5)%v**2))*5.0D
     +-01)
      THETAR%v = (((PRIMR(3)%v**2)+(PRIMR(4)%v**2)+(PRIMR(5)%v**2))*5.0D
     +-01)
      HL%v = (THETAL%v+((PRIML(1)%v*GAMMA%v*GM1INV%v)/PRIML(2)%v))
      HR%v = (THETAR%v+((PRIMR(1)%v*GAMMA%v*GM1INV%v)/PRIMR(2)%v))
      UAVE%v = (PRIML(3)%v*ROEL%v+PRIMR(3)%v*ROER%v)
      VAVE%v = (PRIML(4)%v*ROEL%v+PRIMR(4)%v*ROER%v)
      WAVE%v = (PRIML(5)%v*ROEL%v+PRIMR(5)%v*ROER%v)
      HAVE%v = (HL%v*ROEL%v+HR%v*ROER%v)
      THTAVE%v = (((UAVE%v**2)+(VAVE%v**2)+(WAVE%v**2))*5.0D-01)
      CAVE%v = (GM1%v*(HAVE%v-THTAVE%v))
      CAVE%v = SIN(CAVE%v)
      UHAT%v = (NXHAT%v*UAVE%v+NYHAT%v*VAVE%v+NZHAT%v*WAVE%v)
      UTILDE%v = (NYHAT%v*WAVE%v-NZHAT%v*VAVE%v)
      VTILDE%v = (NZHAT%v*UAVE%v-NXHAT%v*WAVE%v)
      WTILDE%v = (NXHAT%v*VAVE%v-NYHAT%v*UAVE%v)
      LAMCM%v = (UHAT%v-CAVE%v)
      LAMU%v = UHAT%v
      LAMCP%v = (CAVE%v+UHAT%v)
      DELTA%v = (NLEFIX%v*(CAVE%v+UHAT%v))
      DELTA2%v = (DELTA%v**2)
      LAM2%v = (LAMCM%v**2)
      IF (DELTA2%v.LT.LAM2%v) THEN
        ALAMCM%v = LAMCM%v
      ELSE
        ALAMCM%v = (((DELTA2%v+LAM2%v)*5.0D-01)/DELTA2%v)
      ENDIF
      LAM2%v = (LAMCP%v**2)
      IF (DELTA2%v.LT.LAM2%v) THEN
        ALAMCP%v = LAMCP%v
      ELSE
        ALAMCP%v = (((DELTA2%v+LAM2%v)*5.0D-01)/DELTA2%v)
      ENDIF
      DELTA%v = (LEFIX%v*(CAVE%v+UHAT%v))
      DELTA2%v = (DELTA%v*DELTA%v)
      LAM2%v = (LAMU%v**2)
      IF (DELTA2%v.LT.LAM2%v) THEN
        ALAMU%v = LAMU%v
      ELSE
        ALAMU%v = (((DELTA2%v+LAM2%v)*5.0D-01)/DELTA2%v)
      ENDIF
      ALAMCM%v = ((LAMCM%v-ALAMCM%v)*5.0D-01)
      ALAMCP%v = ((LAMCP%v-ALAMCP%v)*5.0D-01)
      ALAMU%v = ((LAMU%v-ALAMU%v)*5.0D-01)
      EL%v = (PRIML(1)%v*GM1INV%v+PRIML(2)%v*THETAL%v)
      RUL%v = (PRIML(2)%v*PRIML(3)%v)
      RVL%v = (PRIML(2)%v*PRIML(4)%v)
      RWL%v = (PRIML(2)%v*PRIML(5)%v)
      ER%v = (PRIMR(1)%v*GM1INV%v+PRIMR(2)%v*THETAR%v)
      RUR%v = (PRIMR(2)%v*PRIMR(3)%v)
      RVR%v = (PRIMR(2)%v*PRIMR(4)%v)
      RWR%v = (PRIMR(2)%v*PRIMR(5)%v)
      DE%v = (ER%v-EL%v)
      DR%v = (PRIMR(2)%v-PRIML(2)%v)
      DRU%v = (RUR%v-RUL%v)
      DRV%v = (RVR%v-RVL%v)
      DRW%v = (RWR%v-RWL%v)
      UDDRU%v = (DRU%v*UAVE%v+DRV%v*VAVE%v+DRW%v*WAVE%v)
      OMEGA%v = ((GM1%v/CAVE%v)*(DE%v+DR%v*THTAVE%v-UDDRU%v))
      NDDRU%v = (DRU%v*NXHAT%v+DRV%v*NYHAT%v+DRW%v*NZHAT%v)
      ALP1%v = ((OMEGA%v+DR%v*UHAT%v-NDDRU%v)*5.0D-01)
      ALP2%v = (DRW%v*NYHAT%v+DR%v*(CAVE%v*NXHAT%v-UTILDE%v)+OMEGA%v*(-N
     +XHAT%v)-DRV%v*NZHAT%v)
      ALP3%v = (DRU%v*NZHAT%v+DR%v*(CAVE%v*NYHAT%v-VTILDE%v)+OMEGA%v*(-N
     +YHAT%v)-DRW%v*NXHAT%v)
      ALP4%v = (DRV%v*NXHAT%v+DR%v*(CAVE%v*NZHAT%v-WTILDE%v)+OMEGA%v*(-N
     +ZHAT%v)-DRU%v*NYHAT%v)
      ALP5%v = ((NDDRU%v+OMEGA%v-DR%v*UHAT%v)*5.0D-01)
      ALP1%v = (ALAMCM%v*ALP1%v)
      ALP2%v = (ALAMU%v*ALP2%v)
      ALP3%v = (ALAMU%v*ALP3%v)
      ALP4%v = (ALAMU%v*ALP4%v)
      ALP5%v = (ALAMCP%v*ALP5%v)
      ALP15P%v = (ALP1%v+ALP5%v)
      ALP15M%v = (ALP1%v-ALP5%v)
      MU%v = ((ALP15P%v/CAVE%v)+ALP2%v*NXHAT%v+ALP3%v*NYHAT%v+ALP4%v*NZH
     +AT%v)
      DSS1%v = (MU%v*THTAVE%v+ALP15P%v*GM1INV%v*CAVE%v-ALP15M%v*UHAT%v+A
     +LP2%v*UTILDE%v+ALP3%v*VTILDE%v+ALP4%v*WTILDE%v)
      DSS2%v = MU%v
      DSS3%v = (ALP3%v*NZHAT%v+MU%v*UAVE%v-ALP15M%v*NXHAT%v-ALP4%v*NYHAT
     +%v)
      DSS4%v = (ALP4%v*NXHAT%v+MU%v*VAVE%v-ALP15M%v*NYHAT%v-ALP2%v*NZHAT
     +%v)
      DSS5%v = (ALP2%v*NYHAT%v+MU%v*WAVE%v-ALP15M%v*NZHAT%v-ALP3%v*NXHAT
     +%v)
      UHATL%v = (PRIML(3)%v*NXHAT%v+PRIML(4)%v*NYHAT%v+PRIML(5)%v*NZHAT%
     +v)
      FLUX(1)%v = (NSIZE%v*(DSS1%v+UHATL%v*(PRIML(1)%v+EL%v)))
      FLUX(2)%v = (NSIZE%v*(DSS2%v+PRIML(2)%v*UHATL%v))
      FLUX(3)%v = (NSIZE%v*(DSS3%v+PRIML(1)%v*NXHAT%v+RUL%v*UHATL%v))
      FLUX(4)%v = (NSIZE%v*(DSS4%v+PRIML(1)%v*NYHAT%v+RVL%v*UHATL%v))
      FLUX(5)%v = (NSIZE%v*(DSS5%v+PRIML(1)%v*NZHAT%v+RWL%v*UHATL%v))

          end if
          if (our_rev_mode%tape) then
! taping
C$OPENAD XXX Template ad_template.f
      OpenAD_Symbol_0 = ((NRM(1)%v**2)+(NRM(2)%v**2)+(NRM(3)%v**2))
      NSIZE%v = SIN(OpenAD_Symbol_0)
      OpenAD_Symbol_2 = (2*(NRM(1)%v**(2-INT(1_w2f__i8))))
      OpenAD_Symbol_4 = (2*(NRM(2)%v**(2-INT(1_w2f__i8))))
      OpenAD_Symbol_6 = (2*(NRM(3)%v**(2-INT(1_w2f__i8))))
      OpenAD_Symbol_1 = COS(OpenAD_Symbol_0)
      OpenAD_Symbol_325 = (OpenAD_Symbol_6 * OpenAD_Symbol_1)
      OpenAD_Symbol_326 = (OpenAD_Symbol_4 * OpenAD_Symbol_1)
      OpenAD_Symbol_327 = (OpenAD_Symbol_2 * OpenAD_Symbol_1)
          double_tape(double_tape_pointer) = OpenAD_Symbol_325
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_326
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_327
          double_tape_pointer = double_tape_pointer+1
      IF (MCHEPS.LT.NSIZE%v) THEN
        NSIZEI%v = (1.0D00/NSIZE%v)
        OpenAD_Symbol_9 = (-(1.0D00/(NSIZE%v*NSIZE%v)))
          double_tape(double_tape_pointer) = OpenAD_Symbol_9
          double_tape_pointer = double_tape_pointer+1
        OpenAD_Symbol_442 = 1_w2f__i8
          integer_tape(integer_tape_pointer) = OpenAD_Symbol_442
          integer_tape_pointer = integer_tape_pointer+1
      ELSE
        NSIZEI%v = 0.0D00
        OpenAD_Symbol_443 = 0_w2f__i8
          integer_tape(integer_tape_pointer) = OpenAD_Symbol_443
          integer_tape_pointer = integer_tape_pointer+1
      ENDIF
      NXHAT%v = (NRM(1)%v*NSIZEI%v)
      OpenAD_Symbol_10 = NSIZEI%v
      OpenAD_Symbol_11 = NRM(1)%v
      NYHAT%v = (NRM(2)%v*NSIZEI%v)
      OpenAD_Symbol_12 = NSIZEI%v
      OpenAD_Symbol_13 = NRM(2)%v
      NZHAT%v = (NRM(3)%v*NSIZEI%v)
      OpenAD_Symbol_14 = NSIZEI%v
      OpenAD_Symbol_15 = NRM(3)%v
      OpenAD_Symbol_20 = (PRIMR(2)%v/PRIML(2)%v)
      OpenAD_Symbol_16 = (SIN(OpenAD_Symbol_20) + 1.0D00)
      ROEL%v = (1.0D00/OpenAD_Symbol_16)
      OpenAD_Symbol_22 = (INT(1_w2f__i8)/PRIML(2)%v)
      OpenAD_Symbol_23 = (-(PRIMR(2)%v/(PRIML(2)%v*PRIML(2)%v)))
      OpenAD_Symbol_21 = COS(OpenAD_Symbol_20)
      OpenAD_Symbol_18 = (-(1.0D00 /(OpenAD_Symbol_16 *
     >  OpenAD_Symbol_16)))
      ROER%v = (1.0D00-ROEL%v)
      OpenAD_Symbol_25 = ((PRIML(3)%v**2)+(PRIML(4)%v**2)+(PRIML(5)%v**2
     +))
      THETAL%v = (OpenAD_Symbol_25*5.0D-01)
      OpenAD_Symbol_27 = (2*(PRIML(3)%v**(2-INT(1_w2f__i8))))
      OpenAD_Symbol_29 = (2*(PRIML(4)%v**(2-INT(1_w2f__i8))))
      OpenAD_Symbol_31 = (2*(PRIML(5)%v**(2-INT(1_w2f__i8))))
      OpenAD_Symbol_33 = ((PRIMR(3)%v**2)+(PRIMR(4)%v**2)+(PRIMR(5)%v**2
     +))
      THETAR%v = (OpenAD_Symbol_33*5.0D-01)
      OpenAD_Symbol_35 = (2*(PRIMR(3)%v**(2-INT(1_w2f__i8))))
      OpenAD_Symbol_37 = (2*(PRIMR(4)%v**(2-INT(1_w2f__i8))))
      OpenAD_Symbol_39 = (2*(PRIMR(5)%v**(2-INT(1_w2f__i8))))
      OpenAD_Symbol_44 = (GAMMA%v*GM1INV%v)
      OpenAD_Symbol_41 = (PRIML(1)%v*OpenAD_Symbol_44)
      HL%v = (THETAL%v+(OpenAD_Symbol_41/PRIML(2)%v))
      OpenAD_Symbol_45 = OpenAD_Symbol_44
      OpenAD_Symbol_47 = GM1INV%v
      OpenAD_Symbol_48 = GAMMA%v
      OpenAD_Symbol_46 = PRIML(1)%v
      OpenAD_Symbol_42 = (INT(1_w2f__i8)/PRIML(2)%v)
      OpenAD_Symbol_43 = (-(OpenAD_Symbol_41/(PRIML(2)%v*PRIML(2)%v)))
      OpenAD_Symbol_52 = (GAMMA%v*GM1INV%v)
      OpenAD_Symbol_49 = (PRIMR(1)%v*OpenAD_Symbol_52)
      HR%v = (THETAR%v+(OpenAD_Symbol_49/PRIMR(2)%v))
      OpenAD_Symbol_53 = OpenAD_Symbol_52
      OpenAD_Symbol_55 = GM1INV%v
      OpenAD_Symbol_56 = GAMMA%v
      OpenAD_Symbol_54 = PRIMR(1)%v
      OpenAD_Symbol_50 = (INT(1_w2f__i8)/PRIMR(2)%v)
      OpenAD_Symbol_51 = (-(OpenAD_Symbol_49/(PRIMR(2)%v*PRIMR(2)%v)))
      UAVE%v = (PRIML(3)%v*ROEL%v+PRIMR(3)%v*ROER%v)
      OpenAD_Symbol_57 = ROEL%v
      OpenAD_Symbol_58 = PRIML(3)%v
      OpenAD_Symbol_59 = ROER%v
      OpenAD_Symbol_60 = PRIMR(3)%v
      VAVE%v = (PRIML(4)%v*ROEL%v+PRIMR(4)%v*ROER%v)
      OpenAD_Symbol_61 = ROEL%v
      OpenAD_Symbol_62 = PRIML(4)%v
      OpenAD_Symbol_63 = ROER%v
      OpenAD_Symbol_64 = PRIMR(4)%v
      WAVE%v = (PRIML(5)%v*ROEL%v+PRIMR(5)%v*ROER%v)
      OpenAD_Symbol_65 = ROEL%v
      OpenAD_Symbol_66 = PRIML(5)%v
      OpenAD_Symbol_67 = ROER%v
      OpenAD_Symbol_68 = PRIMR(5)%v
      HAVE%v = (HL%v*ROEL%v+HR%v*ROER%v)
      OpenAD_Symbol_69 = ROEL%v
      OpenAD_Symbol_70 = HL%v
      OpenAD_Symbol_71 = ROER%v
      OpenAD_Symbol_72 = HR%v
      OpenAD_Symbol_73 = ((UAVE%v**2)+(VAVE%v**2)+(WAVE%v**2))
      THTAVE%v = (OpenAD_Symbol_73*5.0D-01)
      OpenAD_Symbol_75 = (2*(UAVE%v**(2-INT(1_w2f__i8))))
      OpenAD_Symbol_77 = (2*(VAVE%v**(2-INT(1_w2f__i8))))
      OpenAD_Symbol_79 = (2*(WAVE%v**(2-INT(1_w2f__i8))))
      OpenAD_Symbol_81 = (HAVE%v-THTAVE%v)
      CAVE%v = (GM1%v*OpenAD_Symbol_81)
      OpenAD_Symbol_82 = OpenAD_Symbol_81
      OpenAD_Symbol_83 = GM1%v
      OpenAD_Symbol_328 = (OpenAD_Symbol_54 * OpenAD_Symbol_50)
      OpenAD_Symbol_329 = (OpenAD_Symbol_46 * OpenAD_Symbol_42)
      OpenAD_Symbol_330 = (5.0D-01 * INT((-1_w2f__i8)) *
     >  OpenAD_Symbol_83)
      OpenAD_Symbol_331 = (OpenAD_Symbol_71 * OpenAD_Symbol_83)
      OpenAD_Symbol_332 = (OpenAD_Symbol_69 * OpenAD_Symbol_83)
      OpenAD_Symbol_333 = (OpenAD_Symbol_18 *(OpenAD_Symbol_70 *
     >  OpenAD_Symbol_83 + INT((-1_w2f__i8)) * OpenAD_Symbol_72 *
     >  OpenAD_Symbol_83))
      OpenAD_Symbol_334 = (OpenAD_Symbol_18 *(OpenAD_Symbol_66 + INT((
     > -1_w2f__i8)) * OpenAD_Symbol_68))
      OpenAD_Symbol_335 = (OpenAD_Symbol_18 *(OpenAD_Symbol_62 + INT((
     > -1_w2f__i8)) * OpenAD_Symbol_64))
      OpenAD_Symbol_336 = (OpenAD_Symbol_18 *(OpenAD_Symbol_58 + INT((
     > -1_w2f__i8)) * OpenAD_Symbol_60))
      OpenAD_Symbol_337 = (OpenAD_Symbol_22 * OpenAD_Symbol_21)
      OpenAD_Symbol_338 = (OpenAD_Symbol_23 * OpenAD_Symbol_21)
      OpenAD_Symbol_339 = (OpenAD_Symbol_45 * OpenAD_Symbol_42)
      OpenAD_Symbol_340 = (OpenAD_Symbol_47 * OpenAD_Symbol_329)
      OpenAD_Symbol_341 = (OpenAD_Symbol_48 * OpenAD_Symbol_329)
      OpenAD_Symbol_342 = (OpenAD_Symbol_53 * OpenAD_Symbol_50)
      OpenAD_Symbol_343 = (OpenAD_Symbol_55 * OpenAD_Symbol_328)
      OpenAD_Symbol_344 = (OpenAD_Symbol_56 * OpenAD_Symbol_328)
          double_tape(double_tape_pointer) = OpenAD_Symbol_10
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_11
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_12
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_13
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_14
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_15
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_337
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_338
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_31
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_27
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_29
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_39
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_35
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_37
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_43
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_339
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_340
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_341
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_51
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_342
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_343
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_344
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_59
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_336
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_57
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_63
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_61
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_335
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_67
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_65
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_334
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_79
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_77
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_75
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_82
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_330
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_331
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_332
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_333
          double_tape_pointer = double_tape_pointer+1
      OpenAD_Symbol_85 = SIN(CAVE%v)
      OpenAD_Symbol_84 = COS(CAVE%v)
      CAVE%v = OpenAD_Symbol_85
      UHAT%v = (NXHAT%v*UAVE%v+NYHAT%v*VAVE%v+NZHAT%v*WAVE%v)
      OpenAD_Symbol_86 = UAVE%v
      OpenAD_Symbol_87 = NXHAT%v
      OpenAD_Symbol_88 = VAVE%v
      OpenAD_Symbol_89 = NYHAT%v
      OpenAD_Symbol_90 = WAVE%v
      OpenAD_Symbol_91 = NZHAT%v
      UTILDE%v = (NYHAT%v*WAVE%v-NZHAT%v*VAVE%v)
      OpenAD_Symbol_92 = WAVE%v
      OpenAD_Symbol_93 = NYHAT%v
      OpenAD_Symbol_94 = VAVE%v
      OpenAD_Symbol_95 = NZHAT%v
      VTILDE%v = (NZHAT%v*UAVE%v-NXHAT%v*WAVE%v)
      OpenAD_Symbol_96 = UAVE%v
      OpenAD_Symbol_97 = NZHAT%v
      OpenAD_Symbol_98 = WAVE%v
      OpenAD_Symbol_99 = NXHAT%v
      WTILDE%v = (NXHAT%v*VAVE%v-NYHAT%v*UAVE%v)
      OpenAD_Symbol_100 = VAVE%v
      OpenAD_Symbol_101 = NXHAT%v
      OpenAD_Symbol_102 = UAVE%v
      OpenAD_Symbol_103 = NYHAT%v
      LAMCM%v = (UHAT%v-CAVE%v)
      LAMU%v = UHAT%v
      LAMCP%v = (CAVE%v+UHAT%v)
      OpenAD_Symbol_104 = (CAVE%v+UHAT%v)
      DELTA%v = (NLEFIX%v*OpenAD_Symbol_104)
      OpenAD_Symbol_105 = OpenAD_Symbol_104
      OpenAD_Symbol_106 = NLEFIX%v
      DELTA2%v = (DELTA%v**2)
      OpenAD_Symbol_107 = (2*(DELTA%v**(2-INT(1_w2f__i8))))
      LAM2%v = (LAMCM%v**2)
      OpenAD_Symbol_109 = (2*(LAMCM%v**(2-INT(1_w2f__i8))))
      OpenAD_Symbol_349 = (OpenAD_Symbol_105 * OpenAD_Symbol_107)
      OpenAD_Symbol_350 = (OpenAD_Symbol_106 * OpenAD_Symbol_107)
      OpenAD_Symbol_351 = (OpenAD_Symbol_94 * INT((-1_w2f__i8)))
      OpenAD_Symbol_352 = (OpenAD_Symbol_95 * INT((-1_w2f__i8)))
      OpenAD_Symbol_353 = (OpenAD_Symbol_98 * INT((-1_w2f__i8)))
      OpenAD_Symbol_354 = (OpenAD_Symbol_99 * INT((-1_w2f__i8)))
      OpenAD_Symbol_355 = (OpenAD_Symbol_102 * INT((-1_w2f__i8)))
      OpenAD_Symbol_356 = (OpenAD_Symbol_103 * INT((-1_w2f__i8)))
          double_tape(double_tape_pointer) = OpenAD_Symbol_84
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_92
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_93
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_351
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_352
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_96
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_97
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_353
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_354
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_100
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_101
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_355
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_356
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_86
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_87
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_88
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_89
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_90
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_91
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_109
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_349
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_350
          double_tape_pointer = double_tape_pointer+1
      IF (DELTA2%v.LT.LAM2%v) THEN
        ALAMCM%v = LAMCM%v
        OpenAD_Symbol_444 = 1_w2f__i8
          integer_tape(integer_tape_pointer) = OpenAD_Symbol_444
          integer_tape_pointer = integer_tape_pointer+1
      ELSE
        OpenAD_Symbol_323 = (DELTA2%v+LAM2%v)
        OpenAD_Symbol_320 = (OpenAD_Symbol_323 * 5.0D-01)
        ALAMCM%v = (OpenAD_Symbol_320/DELTA2%v)
        OpenAD_Symbol_321 = (INT(1_w2f__i8)/DELTA2%v)
        OpenAD_Symbol_322 = (-(OpenAD_Symbol_320/(DELTA2%v*DELTA2%v)))
        OpenAD_Symbol_436 = (5.0D-01 * OpenAD_Symbol_321)
          double_tape(double_tape_pointer) = OpenAD_Symbol_322
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_436
          double_tape_pointer = double_tape_pointer+1
        OpenAD_Symbol_445 = 0_w2f__i8
          integer_tape(integer_tape_pointer) = OpenAD_Symbol_445
          integer_tape_pointer = integer_tape_pointer+1
      ENDIF
      LAM2%v = (LAMCP%v**2)
      OpenAD_Symbol_111 = (2*(LAMCP%v**(2-INT(1_w2f__i8))))
          double_tape(double_tape_pointer) = OpenAD_Symbol_111
          double_tape_pointer = double_tape_pointer+1
      IF (DELTA2%v.LT.LAM2%v) THEN
        ALAMCP%v = LAMCP%v
        OpenAD_Symbol_446 = 1_w2f__i8
          integer_tape(integer_tape_pointer) = OpenAD_Symbol_446
          integer_tape_pointer = integer_tape_pointer+1
      ELSE
        OpenAD_Symbol_318 = (DELTA2%v+LAM2%v)
        OpenAD_Symbol_315 = (OpenAD_Symbol_318 * 5.0D-01)
        ALAMCP%v = (OpenAD_Symbol_315/DELTA2%v)
        OpenAD_Symbol_316 = (INT(1_w2f__i8)/DELTA2%v)
        OpenAD_Symbol_317 = (-(OpenAD_Symbol_315/(DELTA2%v*DELTA2%v)))
        OpenAD_Symbol_434 = (5.0D-01 * OpenAD_Symbol_316)
          double_tape(double_tape_pointer) = OpenAD_Symbol_317
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_434
          double_tape_pointer = double_tape_pointer+1
        OpenAD_Symbol_447 = 0_w2f__i8
          integer_tape(integer_tape_pointer) = OpenAD_Symbol_447
          integer_tape_pointer = integer_tape_pointer+1
      ENDIF
      OpenAD_Symbol_113 = (CAVE%v+UHAT%v)
      DELTA%v = (LEFIX%v*OpenAD_Symbol_113)
      OpenAD_Symbol_114 = OpenAD_Symbol_113
      OpenAD_Symbol_115 = LEFIX%v
      DELTA2%v = (DELTA%v*DELTA%v)
      OpenAD_Symbol_116 = DELTA%v
      OpenAD_Symbol_117 = DELTA%v
      LAM2%v = (LAMU%v**2)
      OpenAD_Symbol_118 = (2*(LAMU%v**(2-INT(1_w2f__i8))))
      OpenAD_Symbol_359 = (OpenAD_Symbol_116 + OpenAD_Symbol_117)
      OpenAD_Symbol_360 = (OpenAD_Symbol_114 * OpenAD_Symbol_359)
      OpenAD_Symbol_361 = (OpenAD_Symbol_115 * OpenAD_Symbol_359)
          double_tape(double_tape_pointer) = OpenAD_Symbol_118
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_360
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_361
          double_tape_pointer = double_tape_pointer+1
      IF (DELTA2%v.LT.LAM2%v) THEN
        ALAMU%v = LAMU%v
        OpenAD_Symbol_448 = 1_w2f__i8
          integer_tape(integer_tape_pointer) = OpenAD_Symbol_448
          integer_tape_pointer = integer_tape_pointer+1
      ELSE
        OpenAD_Symbol_313 = (DELTA2%v+LAM2%v)
        OpenAD_Symbol_310 = (OpenAD_Symbol_313 * 5.0D-01)
        ALAMU%v = (OpenAD_Symbol_310/DELTA2%v)
        OpenAD_Symbol_311 = (INT(1_w2f__i8)/DELTA2%v)
        OpenAD_Symbol_312 = (-(OpenAD_Symbol_310/(DELTA2%v*DELTA2%v)))
        OpenAD_Symbol_432 = (5.0D-01 * OpenAD_Symbol_311)
          double_tape(double_tape_pointer) = OpenAD_Symbol_312
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_432
          double_tape_pointer = double_tape_pointer+1
        OpenAD_Symbol_449 = 0_w2f__i8
          integer_tape(integer_tape_pointer) = OpenAD_Symbol_449
          integer_tape_pointer = integer_tape_pointer+1
      ENDIF
      OpenAD_Symbol_120 = (LAMCM%v-ALAMCM%v)
      ALAMCM%v = (OpenAD_Symbol_120*5.0D-01)
      OpenAD_Symbol_122 = (LAMCP%v-ALAMCP%v)
      ALAMCP%v = (OpenAD_Symbol_122*5.0D-01)
      OpenAD_Symbol_124 = (LAMU%v-ALAMU%v)
      ALAMU%v = (OpenAD_Symbol_124*5.0D-01)
      EL%v = (PRIML(1)%v*GM1INV%v+PRIML(2)%v*THETAL%v)
      OpenAD_Symbol_126 = GM1INV%v
      OpenAD_Symbol_127 = PRIML(1)%v
      OpenAD_Symbol_128 = THETAL%v
      OpenAD_Symbol_129 = PRIML(2)%v
      RUL%v = (PRIML(2)%v*PRIML(3)%v)
      OpenAD_Symbol_130 = PRIML(3)%v
      OpenAD_Symbol_131 = PRIML(2)%v
      RVL%v = (PRIML(2)%v*PRIML(4)%v)
      OpenAD_Symbol_132 = PRIML(4)%v
      OpenAD_Symbol_133 = PRIML(2)%v
      RWL%v = (PRIML(2)%v*PRIML(5)%v)
      OpenAD_Symbol_134 = PRIML(5)%v
      OpenAD_Symbol_135 = PRIML(2)%v
      ER%v = (PRIMR(1)%v*GM1INV%v+PRIMR(2)%v*THETAR%v)
      OpenAD_Symbol_136 = GM1INV%v
      OpenAD_Symbol_137 = PRIMR(1)%v
      OpenAD_Symbol_138 = THETAR%v
      OpenAD_Symbol_139 = PRIMR(2)%v
      RUR%v = (PRIMR(2)%v*PRIMR(3)%v)
      OpenAD_Symbol_140 = PRIMR(3)%v
      OpenAD_Symbol_141 = PRIMR(2)%v
      RVR%v = (PRIMR(2)%v*PRIMR(4)%v)
      OpenAD_Symbol_142 = PRIMR(4)%v
      OpenAD_Symbol_143 = PRIMR(2)%v
      RWR%v = (PRIMR(2)%v*PRIMR(5)%v)
      OpenAD_Symbol_144 = PRIMR(5)%v
      OpenAD_Symbol_145 = PRIMR(2)%v
      DE%v = (ER%v-EL%v)
      DR%v = (PRIMR(2)%v-PRIML(2)%v)
      DRU%v = (RUR%v-RUL%v)
      DRV%v = (RVR%v-RVL%v)
      DRW%v = (RWR%v-RWL%v)
      UDDRU%v = (DRU%v*UAVE%v+DRV%v*VAVE%v+DRW%v*WAVE%v)
      OpenAD_Symbol_146 = UAVE%v
      OpenAD_Symbol_147 = DRU%v
      OpenAD_Symbol_148 = VAVE%v
      OpenAD_Symbol_149 = DRV%v
      OpenAD_Symbol_150 = WAVE%v
      OpenAD_Symbol_151 = DRW%v
      OpenAD_Symbol_152 = (GM1%v/CAVE%v)
      OpenAD_Symbol_153 = (DE%v+DR%v*THTAVE%v-UDDRU%v)
      OMEGA%v = (OpenAD_Symbol_152*OpenAD_Symbol_153)
      OpenAD_Symbol_156 = (INT(1_w2f__i8)/CAVE%v)
      OpenAD_Symbol_157 = (-(GM1%v/(CAVE%v*CAVE%v)))
      OpenAD_Symbol_154 = OpenAD_Symbol_153
      OpenAD_Symbol_158 = THTAVE%v
      OpenAD_Symbol_159 = DR%v
      OpenAD_Symbol_155 = OpenAD_Symbol_152
      NDDRU%v = (DRU%v*NXHAT%v+DRV%v*NYHAT%v+DRW%v*NZHAT%v)
      OpenAD_Symbol_160 = NXHAT%v
      OpenAD_Symbol_161 = DRU%v
      OpenAD_Symbol_162 = NYHAT%v
      OpenAD_Symbol_163 = DRV%v
      OpenAD_Symbol_164 = NZHAT%v
      OpenAD_Symbol_165 = DRW%v
      OpenAD_Symbol_166 = (OMEGA%v+DR%v*UHAT%v-NDDRU%v)
      ALP1%v = (OpenAD_Symbol_166*5.0D-01)
      OpenAD_Symbol_168 = UHAT%v
      OpenAD_Symbol_169 = DR%v
      OpenAD_Symbol_172 = (CAVE%v*NXHAT%v-UTILDE%v)
      OpenAD_Symbol_177 = (-NXHAT%v)
      ALP2%v = (DRW%v*NYHAT%v+DR%v*OpenAD_Symbol_172+OMEGA%v*OpenAD_Symb
     +ol_177-DRV%v*NZHAT%v)
      OpenAD_Symbol_170 = NYHAT%v
      OpenAD_Symbol_171 = DRW%v
      OpenAD_Symbol_173 = OpenAD_Symbol_172
      OpenAD_Symbol_175 = NXHAT%v
      OpenAD_Symbol_176 = CAVE%v
      OpenAD_Symbol_174 = DR%v
      OpenAD_Symbol_178 = OpenAD_Symbol_177
      OpenAD_Symbol_179 = OMEGA%v
      OpenAD_Symbol_180 = NZHAT%v
      OpenAD_Symbol_181 = DRV%v
      OpenAD_Symbol_184 = (CAVE%v*NYHAT%v-VTILDE%v)
      OpenAD_Symbol_189 = (-NYHAT%v)
      ALP3%v = (DRU%v*NZHAT%v+DR%v*OpenAD_Symbol_184+OMEGA%v*OpenAD_Symb
     +ol_189-DRW%v*NXHAT%v)
      OpenAD_Symbol_182 = NZHAT%v
      OpenAD_Symbol_183 = DRU%v
      OpenAD_Symbol_185 = OpenAD_Symbol_184
      OpenAD_Symbol_187 = NYHAT%v
      OpenAD_Symbol_188 = CAVE%v
      OpenAD_Symbol_186 = DR%v
      OpenAD_Symbol_190 = OpenAD_Symbol_189
      OpenAD_Symbol_191 = OMEGA%v
      OpenAD_Symbol_192 = NXHAT%v
      OpenAD_Symbol_193 = DRW%v
      OpenAD_Symbol_196 = (CAVE%v*NZHAT%v-WTILDE%v)
      OpenAD_Symbol_201 = (-NZHAT%v)
      ALP4%v = (DRV%v*NXHAT%v+DR%v*OpenAD_Symbol_196+OMEGA%v*OpenAD_Symb
     +ol_201-DRU%v*NYHAT%v)
      OpenAD_Symbol_194 = NXHAT%v
      OpenAD_Symbol_195 = DRV%v
      OpenAD_Symbol_197 = OpenAD_Symbol_196
      OpenAD_Symbol_199 = NZHAT%v
      OpenAD_Symbol_200 = CAVE%v
      OpenAD_Symbol_198 = DR%v
      OpenAD_Symbol_202 = OpenAD_Symbol_201
      OpenAD_Symbol_203 = OMEGA%v
      OpenAD_Symbol_204 = NYHAT%v
      OpenAD_Symbol_205 = DRU%v
      OpenAD_Symbol_206 = (NDDRU%v+OMEGA%v-DR%v*UHAT%v)
      ALP5%v = (OpenAD_Symbol_206*5.0D-01)
      OpenAD_Symbol_208 = UHAT%v
      OpenAD_Symbol_209 = DR%v
      OpenAD_Symbol_363 = (OpenAD_Symbol_156 * OpenAD_Symbol_154)
      OpenAD_Symbol_364 = (OpenAD_Symbol_157 * OpenAD_Symbol_154)
      OpenAD_Symbol_365 = (OpenAD_Symbol_146 * INT((-1_w2f__i8)))
      OpenAD_Symbol_366 = (OpenAD_Symbol_147 * INT((-1_w2f__i8)))
      OpenAD_Symbol_367 = (OpenAD_Symbol_148 * INT((-1_w2f__i8)))
      OpenAD_Symbol_368 = (OpenAD_Symbol_149 * INT((-1_w2f__i8)))
      OpenAD_Symbol_369 = (OpenAD_Symbol_150 * INT((-1_w2f__i8)))
      OpenAD_Symbol_370 = (OpenAD_Symbol_151 * INT((-1_w2f__i8)))
      OpenAD_Symbol_371 = (INT((-1_w2f__i8)) * OpenAD_Symbol_179)
      OpenAD_Symbol_372 = (OpenAD_Symbol_180 * INT((-1_w2f__i8)))
      OpenAD_Symbol_373 = (OpenAD_Symbol_181 * INT((-1_w2f__i8)))
      OpenAD_Symbol_374 = (INT((-1_w2f__i8)) * OpenAD_Symbol_191)
      OpenAD_Symbol_375 = (OpenAD_Symbol_192 * INT((-1_w2f__i8)))
      OpenAD_Symbol_376 = (OpenAD_Symbol_193 * INT((-1_w2f__i8)))
      OpenAD_Symbol_377 = (INT((-1_w2f__i8)) * OpenAD_Symbol_203)
      OpenAD_Symbol_378 = (OpenAD_Symbol_204 * INT((-1_w2f__i8)))
      OpenAD_Symbol_379 = (OpenAD_Symbol_205 * INT((-1_w2f__i8)))
      OpenAD_Symbol_380 = (OpenAD_Symbol_208 * INT((-1_w2f__i8)))
      OpenAD_Symbol_381 = (OpenAD_Symbol_209 * INT((-1_w2f__i8)))
          double_tape(double_tape_pointer) = OpenAD_Symbol_130
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_131
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_132
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_133
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_134
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_135
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_140
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_141
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_142
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_143
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_144
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_145
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_126
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_127
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_128
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_129
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_175
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_176
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_187
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_188
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_199
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_200
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_136
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_137
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_138
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_139
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_158
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_159
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_365
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_366
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_367
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_368
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_369
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_370
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_160
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_161
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_162
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_163
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_164
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_165
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_155
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_363
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_364
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_168
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_169
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_380
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_381
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_170
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_171
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_173
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_174
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_178
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_371
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_372
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_373
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_182
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_183
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_185
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_186
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_190
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_374
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_375
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_376
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_194
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_195
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_197
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_198
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_202
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_377
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_378
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_379
          double_tape_pointer = double_tape_pointer+1
      OpenAD_Symbol_212 = (ALAMCM%v*ALP1%v)
      OpenAD_Symbol_210 = ALP1%v
      OpenAD_Symbol_211 = ALAMCM%v
      ALP1%v = OpenAD_Symbol_212
      OpenAD_Symbol_215 = (ALAMU%v*ALP2%v)
      OpenAD_Symbol_213 = ALP2%v
      OpenAD_Symbol_214 = ALAMU%v
      ALP2%v = OpenAD_Symbol_215
      OpenAD_Symbol_218 = (ALAMU%v*ALP3%v)
      OpenAD_Symbol_216 = ALP3%v
      OpenAD_Symbol_217 = ALAMU%v
      ALP3%v = OpenAD_Symbol_218
      OpenAD_Symbol_221 = (ALAMU%v*ALP4%v)
      OpenAD_Symbol_219 = ALP4%v
      OpenAD_Symbol_220 = ALAMU%v
      ALP4%v = OpenAD_Symbol_221
      OpenAD_Symbol_224 = (ALAMCP%v*ALP5%v)
      OpenAD_Symbol_222 = ALP5%v
      OpenAD_Symbol_223 = ALAMCP%v
      ALP5%v = OpenAD_Symbol_224
      ALP15P%v = (ALP1%v+ALP5%v)
      ALP15M%v = (ALP1%v-ALP5%v)
      MU%v = ((ALP15P%v/CAVE%v)+ALP2%v*NXHAT%v+ALP3%v*NYHAT%v+ALP4%v*NZH
     +AT%v)
      OpenAD_Symbol_225 = (INT(1_w2f__i8)/CAVE%v)
      OpenAD_Symbol_226 = (-(ALP15P%v/(CAVE%v*CAVE%v)))
      OpenAD_Symbol_227 = NXHAT%v
      OpenAD_Symbol_228 = ALP2%v
      OpenAD_Symbol_229 = NYHAT%v
      OpenAD_Symbol_230 = ALP3%v
      OpenAD_Symbol_231 = NZHAT%v
      OpenAD_Symbol_232 = ALP4%v
      OpenAD_Symbol_235 = (GM1INV%v*CAVE%v)
      DSS1%v = (MU%v*THTAVE%v+ALP15P%v*OpenAD_Symbol_235-ALP15M%v*UHAT%v
     ++ALP2%v*UTILDE%v+ALP3%v*VTILDE%v+ALP4%v*WTILDE%v)
      OpenAD_Symbol_233 = THTAVE%v
      OpenAD_Symbol_234 = MU%v
      OpenAD_Symbol_236 = OpenAD_Symbol_235
      OpenAD_Symbol_238 = CAVE%v
      OpenAD_Symbol_239 = GM1INV%v
      OpenAD_Symbol_237 = ALP15P%v
      OpenAD_Symbol_240 = UHAT%v
      OpenAD_Symbol_241 = ALP15M%v
      OpenAD_Symbol_242 = UTILDE%v
      OpenAD_Symbol_243 = ALP2%v
      OpenAD_Symbol_244 = VTILDE%v
      OpenAD_Symbol_245 = ALP3%v
      OpenAD_Symbol_246 = WTILDE%v
      OpenAD_Symbol_247 = ALP4%v
      DSS2%v = MU%v
      DSS3%v = (ALP3%v*NZHAT%v+MU%v*UAVE%v-ALP15M%v*NXHAT%v-ALP4%v*NYHAT
     +%v)
      OpenAD_Symbol_248 = NZHAT%v
      OpenAD_Symbol_249 = ALP3%v
      OpenAD_Symbol_250 = UAVE%v
      OpenAD_Symbol_251 = MU%v
      OpenAD_Symbol_252 = NXHAT%v
      OpenAD_Symbol_253 = ALP15M%v
      OpenAD_Symbol_254 = NYHAT%v
      OpenAD_Symbol_255 = ALP4%v
      DSS4%v = (ALP4%v*NXHAT%v+MU%v*VAVE%v-ALP15M%v*NYHAT%v-ALP2%v*NZHAT
     +%v)
      OpenAD_Symbol_256 = NXHAT%v
      OpenAD_Symbol_257 = ALP4%v
      OpenAD_Symbol_258 = VAVE%v
      OpenAD_Symbol_259 = MU%v
      OpenAD_Symbol_260 = NYHAT%v
      OpenAD_Symbol_261 = ALP15M%v
      OpenAD_Symbol_262 = NZHAT%v
      OpenAD_Symbol_263 = ALP2%v
      DSS5%v = (ALP2%v*NYHAT%v+MU%v*WAVE%v-ALP15M%v*NZHAT%v-ALP3%v*NXHAT
     +%v)
      OpenAD_Symbol_264 = NYHAT%v
      OpenAD_Symbol_265 = ALP2%v
      OpenAD_Symbol_266 = WAVE%v
      OpenAD_Symbol_267 = MU%v
      OpenAD_Symbol_268 = NZHAT%v
      OpenAD_Symbol_269 = ALP15M%v
      OpenAD_Symbol_270 = NXHAT%v
      OpenAD_Symbol_271 = ALP3%v
      UHATL%v = (PRIML(3)%v*NXHAT%v+PRIML(4)%v*NYHAT%v+PRIML(5)%v*NZHAT%
     +v)
      OpenAD_Symbol_272 = NXHAT%v
      OpenAD_Symbol_273 = PRIML(3)%v
      OpenAD_Symbol_274 = NYHAT%v
      OpenAD_Symbol_275 = PRIML(4)%v
      OpenAD_Symbol_276 = NZHAT%v
      OpenAD_Symbol_277 = PRIML(5)%v
      OpenAD_Symbol_281 = (PRIML(1)%v+EL%v)
      OpenAD_Symbol_278 = (DSS1%v+UHATL%v*OpenAD_Symbol_281)
      FLUX(1)%v = (NSIZE%v*OpenAD_Symbol_278)
      OpenAD_Symbol_279 = OpenAD_Symbol_278
      OpenAD_Symbol_282 = OpenAD_Symbol_281
      OpenAD_Symbol_283 = UHATL%v
      OpenAD_Symbol_280 = NSIZE%v
      OpenAD_Symbol_394 = (OpenAD_Symbol_282 * OpenAD_Symbol_280)
      OpenAD_Symbol_395 = (OpenAD_Symbol_283 * OpenAD_Symbol_280)
      OpenAD_Symbol_396 = (OpenAD_Symbol_246 * OpenAD_Symbol_280)
      OpenAD_Symbol_397 = (OpenAD_Symbol_247 * OpenAD_Symbol_280)
      OpenAD_Symbol_398 = (OpenAD_Symbol_244 * OpenAD_Symbol_280)
      OpenAD_Symbol_399 = (OpenAD_Symbol_245 * OpenAD_Symbol_280)
      OpenAD_Symbol_400 = (OpenAD_Symbol_242 * OpenAD_Symbol_280)
      OpenAD_Symbol_401 = (OpenAD_Symbol_243 * OpenAD_Symbol_280)
      OpenAD_Symbol_402 = (OpenAD_Symbol_233 * OpenAD_Symbol_280)
      OpenAD_Symbol_403 = (OpenAD_Symbol_234 * OpenAD_Symbol_280)
      OpenAD_Symbol_404 = (OpenAD_Symbol_236 * OpenAD_Symbol_280)
      OpenAD_Symbol_405 = (OpenAD_Symbol_238 * OpenAD_Symbol_237 *
     >  OpenAD_Symbol_280)
      OpenAD_Symbol_406 = (OpenAD_Symbol_239 * OpenAD_Symbol_237 *
     >  OpenAD_Symbol_280)
      OpenAD_Symbol_407 = (INT((-1_w2f__i8)) * OpenAD_Symbol_280)
      OpenAD_Symbol_408 = (OpenAD_Symbol_240 * OpenAD_Symbol_407)
      OpenAD_Symbol_409 = (OpenAD_Symbol_241 * OpenAD_Symbol_407)
      OpenAD_Symbol_410 = (OpenAD_Symbol_254 * INT((-1_w2f__i8)))
      OpenAD_Symbol_411 = (OpenAD_Symbol_255 * INT((-1_w2f__i8)))
      OpenAD_Symbol_412 = (OpenAD_Symbol_262 * INT((-1_w2f__i8)))
      OpenAD_Symbol_413 = (OpenAD_Symbol_263 * INT((-1_w2f__i8)))
      OpenAD_Symbol_414 = (OpenAD_Symbol_270 * INT((-1_w2f__i8)))
      OpenAD_Symbol_415 = (OpenAD_Symbol_271 * INT((-1_w2f__i8)))
      OpenAD_Symbol_416 = (OpenAD_Symbol_268 * INT((-1_w2f__i8)))
      OpenAD_Symbol_417 = (OpenAD_Symbol_269 * INT((-1_w2f__i8)))
      OpenAD_Symbol_418 = (OpenAD_Symbol_260 * INT((-1_w2f__i8)))
      OpenAD_Symbol_419 = (OpenAD_Symbol_261 * INT((-1_w2f__i8)))
      OpenAD_Symbol_420 = (OpenAD_Symbol_252 * INT((-1_w2f__i8)))
      OpenAD_Symbol_421 = (OpenAD_Symbol_253 * INT((-1_w2f__i8)))
          double_tape(double_tape_pointer) = OpenAD_Symbol_210
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_211
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_213
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_214
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_216
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_217
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_219
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_220
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_222
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_223
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_272
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_273
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_274
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_275
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_276
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_277
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_225
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_226
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_227
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_228
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_229
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_230
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_231
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_232
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_250
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_251
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_410
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_411
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_248
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_249
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_420
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_421
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_258
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_259
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_412
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_413
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_256
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_257
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_418
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_419
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_266
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_267
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_414
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_415
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_264
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_265
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_416
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_417
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_279
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_394
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_395
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_396
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_397
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_398
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_399
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_400
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_401
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_402
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_403
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_404
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_405
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_406
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_408
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_409
          double_tape_pointer = double_tape_pointer+1
      OpenAD_Symbol_284 = (DSS2%v+PRIML(2)%v*UHATL%v)
      FLUX(2)%v = (NSIZE%v*OpenAD_Symbol_284)
      OpenAD_Symbol_285 = OpenAD_Symbol_284
      OpenAD_Symbol_287 = UHATL%v
      OpenAD_Symbol_288 = PRIML(2)%v
      OpenAD_Symbol_286 = NSIZE%v
          double_tape(double_tape_pointer) = OpenAD_Symbol_287
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_288
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_285
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_286
          double_tape_pointer = double_tape_pointer+1
      OpenAD_Symbol_289 = (DSS3%v+PRIML(1)%v*NXHAT%v+RUL%v*UHATL%v)
      FLUX(3)%v = (NSIZE%v*OpenAD_Symbol_289)
      OpenAD_Symbol_290 = OpenAD_Symbol_289
      OpenAD_Symbol_292 = NXHAT%v
      OpenAD_Symbol_293 = PRIML(1)%v
      OpenAD_Symbol_294 = UHATL%v
      OpenAD_Symbol_295 = RUL%v
      OpenAD_Symbol_291 = NSIZE%v
          double_tape(double_tape_pointer) = OpenAD_Symbol_292
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_293
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_294
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_295
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_290
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_291
          double_tape_pointer = double_tape_pointer+1
      OpenAD_Symbol_296 = (DSS4%v+PRIML(1)%v*NYHAT%v+RVL%v*UHATL%v)
      FLUX(4)%v = (NSIZE%v*OpenAD_Symbol_296)
      OpenAD_Symbol_297 = OpenAD_Symbol_296
      OpenAD_Symbol_299 = NYHAT%v
      OpenAD_Symbol_300 = PRIML(1)%v
      OpenAD_Symbol_301 = UHATL%v
      OpenAD_Symbol_302 = RVL%v
      OpenAD_Symbol_298 = NSIZE%v
          double_tape(double_tape_pointer) = OpenAD_Symbol_299
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_300
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_301
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_302
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_297
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_298
          double_tape_pointer = double_tape_pointer+1
      OpenAD_Symbol_303 = (DSS5%v+PRIML(1)%v*NZHAT%v+RWL%v*UHATL%v)
      FLUX(5)%v = (NSIZE%v*OpenAD_Symbol_303)
      OpenAD_Symbol_304 = OpenAD_Symbol_303
      OpenAD_Symbol_306 = NZHAT%v
      OpenAD_Symbol_307 = PRIML(1)%v
      OpenAD_Symbol_308 = UHATL%v
      OpenAD_Symbol_309 = RWL%v
      OpenAD_Symbol_305 = NSIZE%v
          double_tape(double_tape_pointer) = OpenAD_Symbol_306
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_307
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_308
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_309
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_304
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_305
          double_tape_pointer = double_tape_pointer+1

          end if 
          if (our_rev_mode%adjoint) then
! adjoint
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_531 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_532 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_533 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_534 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_535 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_536 = double_tape(double_tape_pointer)
          OpenAD_Symbol_431%d = OpenAD_Symbol_431%d+FLUX(5)%d*(OpenAD_Sy
     +mbol_531)
          NSIZE%d = NSIZE%d+FLUX(5)%d*(OpenAD_Symbol_532)
          FLUX(5)%d = 0.0d0
          UHATL%d = UHATL%d+OpenAD_Symbol_431%d*(OpenAD_Symbol_533)
          RWL%d = RWL%d+OpenAD_Symbol_431%d*(OpenAD_Symbol_534)
          NZHAT%d = NZHAT%d+OpenAD_Symbol_431%d*(OpenAD_Symbol_535)
          PRIML(1)%d = PRIML(1)%d+OpenAD_Symbol_431%d*(OpenAD_Symbol_536
     +)
          DSS5%d = DSS5%d+OpenAD_Symbol_431%d
          OpenAD_Symbol_431%d = 0.0d0
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_537 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_538 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_539 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_540 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_541 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_542 = double_tape(double_tape_pointer)
          OpenAD_Symbol_430%d = OpenAD_Symbol_430%d+FLUX(4)%d*(OpenAD_Sy
     +mbol_537)
          NSIZE%d = NSIZE%d+FLUX(4)%d*(OpenAD_Symbol_538)
          FLUX(4)%d = 0.0d0
          UHATL%d = UHATL%d+OpenAD_Symbol_430%d*(OpenAD_Symbol_539)
          RVL%d = RVL%d+OpenAD_Symbol_430%d*(OpenAD_Symbol_540)
          NYHAT%d = NYHAT%d+OpenAD_Symbol_430%d*(OpenAD_Symbol_541)
          PRIML(1)%d = PRIML(1)%d+OpenAD_Symbol_430%d*(OpenAD_Symbol_542
     +)
          DSS4%d = DSS4%d+OpenAD_Symbol_430%d
          OpenAD_Symbol_430%d = 0.0d0
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_543 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_544 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_545 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_546 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_547 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_548 = double_tape(double_tape_pointer)
          OpenAD_Symbol_429%d = OpenAD_Symbol_429%d+FLUX(3)%d*(OpenAD_Sy
     +mbol_543)
          NSIZE%d = NSIZE%d+FLUX(3)%d*(OpenAD_Symbol_544)
          FLUX(3)%d = 0.0d0
          UHATL%d = UHATL%d+OpenAD_Symbol_429%d*(OpenAD_Symbol_545)
          RUL%d = RUL%d+OpenAD_Symbol_429%d*(OpenAD_Symbol_546)
          NXHAT%d = NXHAT%d+OpenAD_Symbol_429%d*(OpenAD_Symbol_547)
          PRIML(1)%d = PRIML(1)%d+OpenAD_Symbol_429%d*(OpenAD_Symbol_548
     +)
          DSS3%d = DSS3%d+OpenAD_Symbol_429%d
          OpenAD_Symbol_429%d = 0.0d0
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_549 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_550 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_551 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_552 = double_tape(double_tape_pointer)
          OpenAD_Symbol_428%d = OpenAD_Symbol_428%d+FLUX(2)%d*(OpenAD_Sy
     +mbol_549)
          NSIZE%d = NSIZE%d+FLUX(2)%d*(OpenAD_Symbol_550)
          FLUX(2)%d = 0.0d0
          UHATL%d = UHATL%d+OpenAD_Symbol_428%d*(OpenAD_Symbol_551)
          PRIML(2)%d = PRIML(2)%d+OpenAD_Symbol_428%d*(OpenAD_Symbol_552
     +)
          DSS2%d = DSS2%d+OpenAD_Symbol_428%d
          OpenAD_Symbol_428%d = 0.0d0
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_553 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_554 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_555 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_556 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_557 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_558 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_559 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_560 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_561 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_562 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_563 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_564 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_565 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_566 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_567 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_568 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_569 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_570 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_571 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_572 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_573 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_574 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_575 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_576 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_577 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_578 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_579 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_580 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_581 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_582 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_583 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_584 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_585 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_586 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_587 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_588 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_589 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_590 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_591 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_592 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_593 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_594 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_595 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_596 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_597 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_598 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_599 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_600 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_601 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_602 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_603 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_604 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_605 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_606 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_607 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_608 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_609 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_610 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_611 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_612 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_613 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_614 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_615 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_616 = double_tape(double_tape_pointer)
          UHAT%d = UHAT%d+FLUX(1)%d*(OpenAD_Symbol_553)
          ALP15M%d = ALP15M%d+FLUX(1)%d*(OpenAD_Symbol_554)
          CAVE%d = CAVE%d+FLUX(1)%d*(OpenAD_Symbol_555)
          GM1INV%d = GM1INV%d+FLUX(1)%d*(OpenAD_Symbol_556)
          ALP15P%d = ALP15P%d+FLUX(1)%d*(OpenAD_Symbol_557)
          THTAVE%d = THTAVE%d+FLUX(1)%d*(OpenAD_Symbol_558)
          MU%d = MU%d+FLUX(1)%d*(OpenAD_Symbol_559)
          UTILDE%d = UTILDE%d+FLUX(1)%d*(OpenAD_Symbol_560)
          ALP2%d = ALP2%d+FLUX(1)%d*(OpenAD_Symbol_561)
          VTILDE%d = VTILDE%d+FLUX(1)%d*(OpenAD_Symbol_562)
          ALP3%d = ALP3%d+FLUX(1)%d*(OpenAD_Symbol_563)
          WTILDE%d = WTILDE%d+FLUX(1)%d*(OpenAD_Symbol_564)
          ALP4%d = ALP4%d+FLUX(1)%d*(OpenAD_Symbol_565)
          OpenAD_Symbol_427%d = OpenAD_Symbol_427%d+FLUX(1)%d*(OpenAD_Sy
     +mbol_566)
          UHATL%d = UHATL%d+FLUX(1)%d*(OpenAD_Symbol_567)
          NSIZE%d = NSIZE%d+FLUX(1)%d*(OpenAD_Symbol_568)
          FLUX(1)%d = 0.0d0
          NZHAT%d = NZHAT%d+DSS5%d*(OpenAD_Symbol_569)
          ALP15M%d = ALP15M%d+DSS5%d*(OpenAD_Symbol_570)
          NYHAT%d = NYHAT%d+DSS5%d*(OpenAD_Symbol_571)
          ALP2%d = ALP2%d+DSS5%d*(OpenAD_Symbol_572)
          NXHAT%d = NXHAT%d+DSS5%d*(OpenAD_Symbol_573)
          ALP3%d = ALP3%d+DSS5%d*(OpenAD_Symbol_574)
          WAVE%d = WAVE%d+DSS5%d*(OpenAD_Symbol_575)
          MU%d = MU%d+DSS5%d*(OpenAD_Symbol_576)
          DSS5%d = 0.0d0
          NYHAT%d = NYHAT%d+DSS4%d*(OpenAD_Symbol_577)
          ALP15M%d = ALP15M%d+DSS4%d*(OpenAD_Symbol_578)
          NXHAT%d = NXHAT%d+DSS4%d*(OpenAD_Symbol_579)
          ALP4%d = ALP4%d+DSS4%d*(OpenAD_Symbol_580)
          NZHAT%d = NZHAT%d+DSS4%d*(OpenAD_Symbol_581)
          ALP2%d = ALP2%d+DSS4%d*(OpenAD_Symbol_582)
          VAVE%d = VAVE%d+DSS4%d*(OpenAD_Symbol_583)
          MU%d = MU%d+DSS4%d*(OpenAD_Symbol_584)
          DSS4%d = 0.0d0
          NXHAT%d = NXHAT%d+DSS3%d*(OpenAD_Symbol_585)
          ALP15M%d = ALP15M%d+DSS3%d*(OpenAD_Symbol_586)
          NZHAT%d = NZHAT%d+DSS3%d*(OpenAD_Symbol_587)
          ALP3%d = ALP3%d+DSS3%d*(OpenAD_Symbol_588)
          NYHAT%d = NYHAT%d+DSS3%d*(OpenAD_Symbol_589)
          ALP4%d = ALP4%d+DSS3%d*(OpenAD_Symbol_590)
          UAVE%d = UAVE%d+DSS3%d*(OpenAD_Symbol_591)
          MU%d = MU%d+DSS3%d*(OpenAD_Symbol_592)
          DSS3%d = 0.0d0
          MU%d = MU%d+DSS2%d
          DSS2%d = 0.0d0
          NZHAT%d = NZHAT%d+MU%d*(OpenAD_Symbol_593)
          ALP4%d = ALP4%d+MU%d*(OpenAD_Symbol_594)
          NYHAT%d = NYHAT%d+MU%d*(OpenAD_Symbol_595)
          ALP3%d = ALP3%d+MU%d*(OpenAD_Symbol_596)
          NXHAT%d = NXHAT%d+MU%d*(OpenAD_Symbol_597)
          ALP2%d = ALP2%d+MU%d*(OpenAD_Symbol_598)
          CAVE%d = CAVE%d+MU%d*(OpenAD_Symbol_599)
          ALP15P%d = ALP15P%d+MU%d*(OpenAD_Symbol_600)
          MU%d = 0.0d0
          NZHAT%d = NZHAT%d+UHATL%d*(OpenAD_Symbol_601)
          PRIML(5)%d = PRIML(5)%d+UHATL%d*(OpenAD_Symbol_602)
          NYHAT%d = NYHAT%d+UHATL%d*(OpenAD_Symbol_603)
          PRIML(4)%d = PRIML(4)%d+UHATL%d*(OpenAD_Symbol_604)
          NXHAT%d = NXHAT%d+UHATL%d*(OpenAD_Symbol_605)
          PRIML(3)%d = PRIML(3)%d+UHATL%d*(OpenAD_Symbol_606)
          UHATL%d = 0.0d0
          EL%d = EL%d+OpenAD_Symbol_427%d
          PRIML(1)%d = PRIML(1)%d+OpenAD_Symbol_427%d
          OpenAD_Symbol_427%d = 0.0d0
          ALP5%d = ALP5%d-ALP15M%d
          ALP1%d = ALP1%d+ALP15M%d
          ALP15M%d = 0.0d0
          ALP5%d = ALP5%d+ALP15P%d
          ALP1%d = ALP1%d+ALP15P%d
          ALP15P%d = 0.0d0
          OpenAD_Symbol_426%d = OpenAD_Symbol_426%d+ALP5%d*(OpenAD_Symbo
     +l_607)
          ALAMCP%d = ALAMCP%d+ALP5%d*(OpenAD_Symbol_608)
          ALP5%d = 0.0d0
          OpenAD_Symbol_425%d = OpenAD_Symbol_425%d+ALP4%d*(OpenAD_Symbo
     +l_609)
          ALAMU%d = ALAMU%d+ALP4%d*(OpenAD_Symbol_610)
          ALP4%d = 0.0d0
          OpenAD_Symbol_424%d = OpenAD_Symbol_424%d+ALP3%d*(OpenAD_Symbo
     +l_611)
          ALAMU%d = ALAMU%d+ALP3%d*(OpenAD_Symbol_612)
          ALP3%d = 0.0d0
          OpenAD_Symbol_423%d = OpenAD_Symbol_423%d+ALP2%d*(OpenAD_Symbo
     +l_613)
          ALAMU%d = ALAMU%d+ALP2%d*(OpenAD_Symbol_614)
          ALP2%d = 0.0d0
          OpenAD_Symbol_422%d = OpenAD_Symbol_422%d+ALP1%d*(OpenAD_Symbo
     +l_615)
          ALAMCM%d = ALAMCM%d+ALP1%d*(OpenAD_Symbol_616)
          ALP1%d = 0.0d0
          ALP5%d = ALP5%d+OpenAD_Symbol_426%d
          OpenAD_Symbol_426%d = 0.0d0
          ALP4%d = ALP4%d+OpenAD_Symbol_425%d
          OpenAD_Symbol_425%d = 0.0d0
          ALP3%d = ALP3%d+OpenAD_Symbol_424%d
          OpenAD_Symbol_424%d = 0.0d0
          ALP2%d = ALP2%d+OpenAD_Symbol_423%d
          OpenAD_Symbol_423%d = 0.0d0
          ALP1%d = ALP1%d+OpenAD_Symbol_422%d
          OpenAD_Symbol_422%d = 0.0d0
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_617 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_618 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_619 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_620 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_621 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_622 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_623 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_624 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_625 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_626 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_627 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_628 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_629 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_630 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_631 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_632 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_633 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_634 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_635 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_636 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_637 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_638 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_639 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_640 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_641 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_642 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_643 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_644 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_645 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_646 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_647 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_648 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_649 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_650 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_651 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_652 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_653 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_654 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_655 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_656 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_657 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_658 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_659 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_660 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_661 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_662 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_663 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_664 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_665 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_666 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_667 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_668 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_669 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_670 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_671 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_672 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_673 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_674 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_675 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_676 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_677 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_678 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_679 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_680 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_681 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_682 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_683 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_684 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_685 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_686 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_687 = double_tape(double_tape_pointer)
          NYHAT%d = NYHAT%d+ALP4%d*(OpenAD_Symbol_617)
          DRU%d = DRU%d+ALP4%d*(OpenAD_Symbol_618)
          NZHAT%d = NZHAT%d+ALP4%d*(OpenAD_Symbol_619)
          OMEGA%d = OMEGA%d+ALP4%d*(OpenAD_Symbol_620)
          OpenAD_Symbol_390%d = OpenAD_Symbol_390%d+ALP4%d*(OpenAD_Symbo
     +l_621)
          DR%d = DR%d+ALP4%d*(OpenAD_Symbol_622)
          NXHAT%d = NXHAT%d+ALP4%d*(OpenAD_Symbol_623)
          DRV%d = DRV%d+ALP4%d*(OpenAD_Symbol_624)
          ALP4%d = 0.0d0
          NXHAT%d = NXHAT%d+ALP3%d*(OpenAD_Symbol_625)
          DRW%d = DRW%d+ALP3%d*(OpenAD_Symbol_626)
          NYHAT%d = NYHAT%d+ALP3%d*(OpenAD_Symbol_627)
          OMEGA%d = OMEGA%d+ALP3%d*(OpenAD_Symbol_628)
          OpenAD_Symbol_389%d = OpenAD_Symbol_389%d+ALP3%d*(OpenAD_Symbo
     +l_629)
          DR%d = DR%d+ALP3%d*(OpenAD_Symbol_630)
          NZHAT%d = NZHAT%d+ALP3%d*(OpenAD_Symbol_631)
          DRU%d = DRU%d+ALP3%d*(OpenAD_Symbol_632)
          ALP3%d = 0.0d0
          NZHAT%d = NZHAT%d+ALP2%d*(OpenAD_Symbol_633)
          DRV%d = DRV%d+ALP2%d*(OpenAD_Symbol_634)
          NXHAT%d = NXHAT%d+ALP2%d*(OpenAD_Symbol_635)
          OMEGA%d = OMEGA%d+ALP2%d*(OpenAD_Symbol_636)
          OpenAD_Symbol_388%d = OpenAD_Symbol_388%d+ALP2%d*(OpenAD_Symbo
     +l_637)
          DR%d = DR%d+ALP2%d*(OpenAD_Symbol_638)
          NYHAT%d = NYHAT%d+ALP2%d*(OpenAD_Symbol_639)
          DRW%d = DRW%d+ALP2%d*(OpenAD_Symbol_640)
          ALP2%d = 0.0d0
          OpenAD_Symbol_393%d = OpenAD_Symbol_393%d+ALP5%d*(5.0D-01)
          ALP5%d = 0.0d0
          OpenAD_Symbol_392%d = OpenAD_Symbol_392%d+ALP1%d*(5.0D-01)
          ALP1%d = 0.0d0
          UHAT%d = UHAT%d+OpenAD_Symbol_393%d*(OpenAD_Symbol_641)
          DR%d = DR%d+OpenAD_Symbol_393%d*(OpenAD_Symbol_642)
          OMEGA%d = OMEGA%d+OpenAD_Symbol_393%d
          NDDRU%d = NDDRU%d+OpenAD_Symbol_393%d
          OpenAD_Symbol_393%d = 0.0d0
          UHAT%d = UHAT%d+OpenAD_Symbol_392%d*(OpenAD_Symbol_643)
          DR%d = DR%d+OpenAD_Symbol_392%d*(OpenAD_Symbol_644)
          NDDRU%d = NDDRU%d-OpenAD_Symbol_392%d
          OMEGA%d = OMEGA%d+OpenAD_Symbol_392%d
          OpenAD_Symbol_392%d = 0.0d0
          CAVE%d = CAVE%d+OMEGA%d*(OpenAD_Symbol_645)
          GM1%d = GM1%d+OMEGA%d*(OpenAD_Symbol_646)
          OpenAD_Symbol_391%d = OpenAD_Symbol_391%d+OMEGA%d*(OpenAD_Symb
     +ol_647)
          OMEGA%d = 0.0d0
          NZHAT%d = NZHAT%d+NDDRU%d*(OpenAD_Symbol_648)
          DRW%d = DRW%d+NDDRU%d*(OpenAD_Symbol_649)
          NYHAT%d = NYHAT%d+NDDRU%d*(OpenAD_Symbol_650)
          DRV%d = DRV%d+NDDRU%d*(OpenAD_Symbol_651)
          NXHAT%d = NXHAT%d+NDDRU%d*(OpenAD_Symbol_652)
          DRU%d = DRU%d+NDDRU%d*(OpenAD_Symbol_653)
          NDDRU%d = 0.0d0
          WAVE%d = WAVE%d+OpenAD_Symbol_391%d*(OpenAD_Symbol_654)
          DRW%d = DRW%d+OpenAD_Symbol_391%d*(OpenAD_Symbol_655)
          VAVE%d = VAVE%d+OpenAD_Symbol_391%d*(OpenAD_Symbol_656)
          DRV%d = DRV%d+OpenAD_Symbol_391%d*(OpenAD_Symbol_657)
          UAVE%d = UAVE%d+OpenAD_Symbol_391%d*(OpenAD_Symbol_658)
          DRU%d = DRU%d+OpenAD_Symbol_391%d*(OpenAD_Symbol_659)
          THTAVE%d = THTAVE%d+OpenAD_Symbol_391%d*(OpenAD_Symbol_660)
          DR%d = DR%d+OpenAD_Symbol_391%d*(OpenAD_Symbol_661)
          THETAR%d = THETAR%d+OpenAD_Symbol_391%d*(OpenAD_Symbol_662)
          PRIMR(2)%d = PRIMR(2)%d+OpenAD_Symbol_391%d*(OpenAD_Symbol_663
     +)
          GM1INV%d = GM1INV%d+OpenAD_Symbol_391%d*(OpenAD_Symbol_664)
          PRIMR(1)%d = PRIMR(1)%d+OpenAD_Symbol_391%d*(OpenAD_Symbol_665
     +)
          EL%d = EL%d-OpenAD_Symbol_391%d
          OpenAD_Symbol_391%d = 0.0d0
          NZHAT%d = NZHAT%d+OpenAD_Symbol_390%d*(OpenAD_Symbol_666)
          CAVE%d = CAVE%d+OpenAD_Symbol_390%d*(OpenAD_Symbol_667)
          WTILDE%d = WTILDE%d-OpenAD_Symbol_390%d
          OpenAD_Symbol_390%d = 0.0d0
          NYHAT%d = NYHAT%d+OpenAD_Symbol_389%d*(OpenAD_Symbol_668)
          CAVE%d = CAVE%d+OpenAD_Symbol_389%d*(OpenAD_Symbol_669)
          VTILDE%d = VTILDE%d-OpenAD_Symbol_389%d
          OpenAD_Symbol_389%d = 0.0d0
          NXHAT%d = NXHAT%d+OpenAD_Symbol_388%d*(OpenAD_Symbol_670)
          CAVE%d = CAVE%d+OpenAD_Symbol_388%d*(OpenAD_Symbol_671)
          UTILDE%d = UTILDE%d-OpenAD_Symbol_388%d
          OpenAD_Symbol_388%d = 0.0d0
          THETAL%d = THETAL%d+EL%d*(OpenAD_Symbol_672)
          PRIML(2)%d = PRIML(2)%d+EL%d*(OpenAD_Symbol_673)
          GM1INV%d = GM1INV%d+EL%d*(OpenAD_Symbol_674)
          PRIML(1)%d = PRIML(1)%d+EL%d*(OpenAD_Symbol_675)
          EL%d = 0.0d0
          OpenAD_Symbol_387%d = OpenAD_Symbol_387%d+ALAMU%d*(5.0D-01)
          ALAMU%d = 0.0d0
          OpenAD_Symbol_386%d = OpenAD_Symbol_386%d+ALAMCP%d*(5.0D-01)
          ALAMCP%d = 0.0d0
          OpenAD_Symbol_385%d = OpenAD_Symbol_385%d+ALAMCM%d*(5.0D-01)
          ALAMCM%d = 0.0d0
          PRIMR(5)%d = PRIMR(5)%d+DRW%d*(OpenAD_Symbol_676)
          PRIMR(2)%d = PRIMR(2)%d+DRW%d*(OpenAD_Symbol_677)
          RWL%d = RWL%d-DRW%d
          DRW%d = 0.0d0
          PRIMR(4)%d = PRIMR(4)%d+DRV%d*(OpenAD_Symbol_678)
          PRIMR(2)%d = PRIMR(2)%d+DRV%d*(OpenAD_Symbol_679)
          RVL%d = RVL%d-DRV%d
          DRV%d = 0.0d0
          PRIMR(3)%d = PRIMR(3)%d+DRU%d*(OpenAD_Symbol_680)
          PRIMR(2)%d = PRIMR(2)%d+DRU%d*(OpenAD_Symbol_681)
          RUL%d = RUL%d-DRU%d
          DRU%d = 0.0d0
          PRIML(2)%d = PRIML(2)%d-DR%d
          PRIMR(2)%d = PRIMR(2)%d+DR%d
          DR%d = 0.0d0
          PRIML(5)%d = PRIML(5)%d+RWL%d*(OpenAD_Symbol_682)
          PRIML(2)%d = PRIML(2)%d+RWL%d*(OpenAD_Symbol_683)
          RWL%d = 0.0d0
          PRIML(4)%d = PRIML(4)%d+RVL%d*(OpenAD_Symbol_684)
          PRIML(2)%d = PRIML(2)%d+RVL%d*(OpenAD_Symbol_685)
          RVL%d = 0.0d0
          PRIML(3)%d = PRIML(3)%d+RUL%d*(OpenAD_Symbol_686)
          PRIML(2)%d = PRIML(2)%d+RUL%d*(OpenAD_Symbol_687)
          RUL%d = 0.0d0
          OpenAD_Symbol_384%d = OpenAD_Symbol_384%d-OpenAD_Symbol_387%d
          LAMU%d = LAMU%d+OpenAD_Symbol_387%d
          OpenAD_Symbol_387%d = 0.0d0
          OpenAD_Symbol_383%d = OpenAD_Symbol_383%d-OpenAD_Symbol_386%d
          LAMCP%d = LAMCP%d+OpenAD_Symbol_386%d
          OpenAD_Symbol_386%d = 0.0d0
          OpenAD_Symbol_382%d = OpenAD_Symbol_382%d-OpenAD_Symbol_385%d
          LAMCM%d = LAMCM%d+OpenAD_Symbol_385%d
          OpenAD_Symbol_385%d = 0.0d0
          ALAMU%d = ALAMU%d+OpenAD_Symbol_384%d
          OpenAD_Symbol_384%d = 0.0d0
          ALAMCP%d = ALAMCP%d+OpenAD_Symbol_383%d
          OpenAD_Symbol_383%d = 0.0d0
          ALAMCM%d = ALAMCM%d+OpenAD_Symbol_382%d
          OpenAD_Symbol_382%d = 0.0d0
          integer_tape_pointer = integer_tape_pointer-1
          OpenAD_Symbol_438 = integer_tape(integer_tape_pointer)
      IF(OpenAD_Symbol_438 .ne. 0) THEN
          LAMU%d = LAMU%d+ALAMU%d
          ALAMU%d = 0.0d0
      ELSE
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_688 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_689 = double_tape(double_tape_pointer)
          OpenAD_Symbol_433%d = OpenAD_Symbol_433%d+ALAMU%d*(OpenAD_Symb
     +ol_688)
          DELTA2%d = DELTA2%d+ALAMU%d*(OpenAD_Symbol_689)
          ALAMU%d = 0.0d0
          LAM2%d = LAM2%d+OpenAD_Symbol_433%d
          DELTA2%d = DELTA2%d+OpenAD_Symbol_433%d
          OpenAD_Symbol_433%d = 0.0d0
      ENDIF
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_528 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_529 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_530 = double_tape(double_tape_pointer)
          OpenAD_Symbol_362%d = OpenAD_Symbol_362%d+DELTA2%d*(OpenAD_Sym
     +bol_528)
          LEFIX%d = LEFIX%d+DELTA2%d*(OpenAD_Symbol_529)
          DELTA2%d = 0.0d0
          LAMU%d = LAMU%d+LAM2%d*(OpenAD_Symbol_530)
          LAM2%d = 0.0d0
          UHAT%d = UHAT%d+OpenAD_Symbol_362%d
          CAVE%d = CAVE%d+OpenAD_Symbol_362%d
          OpenAD_Symbol_362%d = 0.0d0
          integer_tape_pointer = integer_tape_pointer-1
          OpenAD_Symbol_439 = integer_tape(integer_tape_pointer)
      IF(OpenAD_Symbol_439 .ne. 0) THEN
          LAMCP%d = LAMCP%d+ALAMCP%d
          ALAMCP%d = 0.0d0
      ELSE
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_690 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_691 = double_tape(double_tape_pointer)
          OpenAD_Symbol_435%d = OpenAD_Symbol_435%d+ALAMCP%d*(OpenAD_Sym
     +bol_690)
          DELTA2%d = DELTA2%d+ALAMCP%d*(OpenAD_Symbol_691)
          ALAMCP%d = 0.0d0
          LAM2%d = LAM2%d+OpenAD_Symbol_435%d
          DELTA2%d = DELTA2%d+OpenAD_Symbol_435%d
          OpenAD_Symbol_435%d = 0.0d0
      ENDIF
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_527 = double_tape(double_tape_pointer)
          LAMCP%d = LAMCP%d+LAM2%d*(OpenAD_Symbol_527)
          LAM2%d = 0.0d0
          integer_tape_pointer = integer_tape_pointer-1
          OpenAD_Symbol_440 = integer_tape(integer_tape_pointer)
      IF(OpenAD_Symbol_440 .ne. 0) THEN
          LAMCM%d = LAMCM%d+ALAMCM%d
          ALAMCM%d = 0.0d0
      ELSE
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_692 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_693 = double_tape(double_tape_pointer)
          OpenAD_Symbol_437%d = OpenAD_Symbol_437%d+ALAMCM%d*(OpenAD_Sym
     +bol_692)
          DELTA2%d = DELTA2%d+ALAMCM%d*(OpenAD_Symbol_693)
          ALAMCM%d = 0.0d0
          LAM2%d = LAM2%d+OpenAD_Symbol_437%d
          DELTA2%d = DELTA2%d+OpenAD_Symbol_437%d
          OpenAD_Symbol_437%d = 0.0d0
      ENDIF
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_466 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_467 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_468 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_469 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_470 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_471 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_472 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_473 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_474 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_475 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_476 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_477 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_478 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_479 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_480 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_481 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_482 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_483 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_484 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_485 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_486 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_487 = double_tape(double_tape_pointer)
          OpenAD_Symbol_358%d = OpenAD_Symbol_358%d+DELTA2%d*(OpenAD_Sym
     +bol_466)
          NLEFIX%d = NLEFIX%d+DELTA2%d*(OpenAD_Symbol_467)
          DELTA2%d = 0.0d0
          LAMCM%d = LAMCM%d+LAM2%d*(OpenAD_Symbol_468)
          LAM2%d = 0.0d0
          UHAT%d = UHAT%d+OpenAD_Symbol_358%d
          CAVE%d = CAVE%d+OpenAD_Symbol_358%d
          OpenAD_Symbol_358%d = 0.0d0
          UHAT%d = UHAT%d+LAMCP%d
          CAVE%d = CAVE%d+LAMCP%d
          LAMCP%d = 0.0d0
          UHAT%d = UHAT%d+LAMU%d
          LAMU%d = 0.0d0
          CAVE%d = CAVE%d-LAMCM%d
          UHAT%d = UHAT%d+LAMCM%d
          LAMCM%d = 0.0d0
          WAVE%d = WAVE%d+UHAT%d*(OpenAD_Symbol_469)
          NZHAT%d = NZHAT%d+UHAT%d*(OpenAD_Symbol_470)
          VAVE%d = VAVE%d+UHAT%d*(OpenAD_Symbol_471)
          NYHAT%d = NYHAT%d+UHAT%d*(OpenAD_Symbol_472)
          UAVE%d = UAVE%d+UHAT%d*(OpenAD_Symbol_473)
          NXHAT%d = NXHAT%d+UHAT%d*(OpenAD_Symbol_474)
          UHAT%d = 0.0d0
          UAVE%d = UAVE%d+WTILDE%d*(OpenAD_Symbol_475)
          NYHAT%d = NYHAT%d+WTILDE%d*(OpenAD_Symbol_476)
          VAVE%d = VAVE%d+WTILDE%d*(OpenAD_Symbol_477)
          NXHAT%d = NXHAT%d+WTILDE%d*(OpenAD_Symbol_478)
          WTILDE%d = 0.0d0
          WAVE%d = WAVE%d+VTILDE%d*(OpenAD_Symbol_479)
          NXHAT%d = NXHAT%d+VTILDE%d*(OpenAD_Symbol_480)
          UAVE%d = UAVE%d+VTILDE%d*(OpenAD_Symbol_481)
          NZHAT%d = NZHAT%d+VTILDE%d*(OpenAD_Symbol_482)
          VTILDE%d = 0.0d0
          VAVE%d = VAVE%d+UTILDE%d*(OpenAD_Symbol_483)
          NZHAT%d = NZHAT%d+UTILDE%d*(OpenAD_Symbol_484)
          WAVE%d = WAVE%d+UTILDE%d*(OpenAD_Symbol_485)
          NYHAT%d = NYHAT%d+UTILDE%d*(OpenAD_Symbol_486)
          UTILDE%d = 0.0d0
          OpenAD_Symbol_357%d = OpenAD_Symbol_357%d+CAVE%d*(OpenAD_Symbo
     +l_487)
          CAVE%d = 0.0d0
          CAVE%d = CAVE%d+OpenAD_Symbol_357%d
          OpenAD_Symbol_357%d = 0.0d0
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_488 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_489 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_490 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_491 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_492 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_493 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_494 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_495 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_496 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_497 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_498 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_499 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_500 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_501 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_502 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_503 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_504 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_505 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_506 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_507 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_508 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_509 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_510 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_511 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_512 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_513 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_514 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_515 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_516 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_517 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_518 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_519 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_520 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_521 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_522 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_523 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_524 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_525 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_526 = double_tape(double_tape_pointer)
          OpenAD_Symbol_345%d = OpenAD_Symbol_345%d+CAVE%d*(OpenAD_Symbo
     +l_488)
          HL%d = HL%d+CAVE%d*(OpenAD_Symbol_489)
          HR%d = HR%d+CAVE%d*(OpenAD_Symbol_490)
          OpenAD_Symbol_348%d = OpenAD_Symbol_348%d+CAVE%d*(OpenAD_Symbo
     +l_491)
          GM1%d = GM1%d+CAVE%d*(OpenAD_Symbol_492)
          CAVE%d = 0.0d0
          OpenAD_Symbol_348%d = OpenAD_Symbol_348%d+THTAVE%d*(5.0D-01)
          THTAVE%d = 0.0d0
          UAVE%d = UAVE%d+OpenAD_Symbol_348%d*(OpenAD_Symbol_493)
          VAVE%d = VAVE%d+OpenAD_Symbol_348%d*(OpenAD_Symbol_494)
          WAVE%d = WAVE%d+OpenAD_Symbol_348%d*(OpenAD_Symbol_495)
          OpenAD_Symbol_348%d = 0.0d0
          OpenAD_Symbol_345%d = OpenAD_Symbol_345%d+WAVE%d*(OpenAD_Symbo
     +l_496)
          PRIML(5)%d = PRIML(5)%d+WAVE%d*(OpenAD_Symbol_497)
          PRIMR(5)%d = PRIMR(5)%d+WAVE%d*(OpenAD_Symbol_498)
          WAVE%d = 0.0d0
          OpenAD_Symbol_345%d = OpenAD_Symbol_345%d+VAVE%d*(OpenAD_Symbo
     +l_499)
          PRIML(4)%d = PRIML(4)%d+VAVE%d*(OpenAD_Symbol_500)
          PRIMR(4)%d = PRIMR(4)%d+VAVE%d*(OpenAD_Symbol_501)
          VAVE%d = 0.0d0
          PRIML(3)%d = PRIML(3)%d+UAVE%d*(OpenAD_Symbol_502)
          OpenAD_Symbol_345%d = OpenAD_Symbol_345%d+UAVE%d*(OpenAD_Symbo
     +l_503)
          PRIMR(3)%d = PRIMR(3)%d+UAVE%d*(OpenAD_Symbol_504)
          UAVE%d = 0.0d0
          GM1INV%d = GM1INV%d+HR%d*(OpenAD_Symbol_505)
          GAMMA%d = GAMMA%d+HR%d*(OpenAD_Symbol_506)
          PRIMR(1)%d = PRIMR(1)%d+HR%d*(OpenAD_Symbol_507)
          PRIMR(2)%d = PRIMR(2)%d+HR%d*(OpenAD_Symbol_508)
          THETAR%d = THETAR%d+HR%d
          HR%d = 0.0d0
          GM1INV%d = GM1INV%d+HL%d*(OpenAD_Symbol_509)
          GAMMA%d = GAMMA%d+HL%d*(OpenAD_Symbol_510)
          PRIML(1)%d = PRIML(1)%d+HL%d*(OpenAD_Symbol_511)
          PRIML(2)%d = PRIML(2)%d+HL%d*(OpenAD_Symbol_512)
          THETAL%d = THETAL%d+HL%d
          HL%d = 0.0d0
          OpenAD_Symbol_347%d = OpenAD_Symbol_347%d+THETAR%d*(5.0D-01)
          THETAR%d = 0.0d0
          OpenAD_Symbol_346%d = OpenAD_Symbol_346%d+THETAL%d*(5.0D-01)
          THETAL%d = 0.0d0
          PRIMR(4)%d = PRIMR(4)%d+OpenAD_Symbol_347%d*(OpenAD_Symbol_513
     +)
          PRIMR(3)%d = PRIMR(3)%d+OpenAD_Symbol_347%d*(OpenAD_Symbol_514
     +)
          PRIMR(5)%d = PRIMR(5)%d+OpenAD_Symbol_347%d*(OpenAD_Symbol_515
     +)
          OpenAD_Symbol_347%d = 0.0d0
          PRIML(4)%d = PRIML(4)%d+OpenAD_Symbol_346%d*(OpenAD_Symbol_516
     +)
          PRIML(3)%d = PRIML(3)%d+OpenAD_Symbol_346%d*(OpenAD_Symbol_517
     +)
          PRIML(5)%d = PRIML(5)%d+OpenAD_Symbol_346%d*(OpenAD_Symbol_518
     +)
          OpenAD_Symbol_346%d = 0.0d0
          PRIML(2)%d = PRIML(2)%d+OpenAD_Symbol_345%d*(OpenAD_Symbol_519
     +)
          PRIMR(2)%d = PRIMR(2)%d+OpenAD_Symbol_345%d*(OpenAD_Symbol_520
     +)
          OpenAD_Symbol_345%d = 0.0d0
          NSIZEI%d = NSIZEI%d+NZHAT%d*(OpenAD_Symbol_521)
          NRM(3)%d = NRM(3)%d+NZHAT%d*(OpenAD_Symbol_522)
          NZHAT%d = 0.0d0
          NSIZEI%d = NSIZEI%d+NYHAT%d*(OpenAD_Symbol_523)
          NRM(2)%d = NRM(2)%d+NYHAT%d*(OpenAD_Symbol_524)
          NYHAT%d = 0.0d0
          NSIZEI%d = NSIZEI%d+NXHAT%d*(OpenAD_Symbol_525)
          NRM(1)%d = NRM(1)%d+NXHAT%d*(OpenAD_Symbol_526)
          NXHAT%d = 0.0d0
          integer_tape_pointer = integer_tape_pointer-1
          OpenAD_Symbol_441 = integer_tape(integer_tape_pointer)
      IF(OpenAD_Symbol_441 .ne. 0) THEN
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_465 = double_tape(double_tape_pointer)
          NSIZE%d = NSIZE%d+NSIZEI%d*(OpenAD_Symbol_465)
          NSIZEI%d = 0.0d0
      ELSE
          NSIZEI%d = 0.0d0
      ENDIF
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_462 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_463 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_464 = double_tape(double_tape_pointer)
          NRM(1)%d = NRM(1)%d+NSIZE%d*(OpenAD_Symbol_462)
          NRM(2)%d = NRM(2)%d+NSIZE%d*(OpenAD_Symbol_463)
          NRM(3)%d = NRM(3)%d+NSIZE%d*(OpenAD_Symbol_464)
          NSIZE%d = 0.0d0

          end if 
        end subroutine ad_roehf5
