
C ========== begin copyright notice ==============
C This file is part of 
C ---------------
C xaifBooster
C ---------------
C Distributed under the BSD license as follows:
C Copyright (c) 2005, The University of Chicago
C All rights reserved.
C
C Redistribution and use in source and binary forms, 
C with or without modification, are permitted provided that the following conditions are met:
C
C    - Redistributions of source code must retain the above copyright notice, 
C      this list of conditions and the following disclaimer.
C    - Redistributions in binary form must reproduce the above copyright notice, 
C      this list of conditions and the following disclaimer in the documentation 
C      and/or other materials provided with the distribution.
C    - Neither the name of The University of Chicago nor the names of its contributors 
C      may be used to endorse or promote products derived from this software without 
C      specific prior written permission.
C
C THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY 
C EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES 
C OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT 
C SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, 
C INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
C PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
C INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT 
C LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
C OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
C 
C General Information:
C xaifBooster is intended for the transformation of 
C numerical programs represented as xml files according 
C to the XAIF schema. It is part of the OpenAD framework. 
C The main application is automatic 
C differentiation, i.e. the generation of code for 
C the computation of derivatives. 
C The following people are the principal authors of the 
C current version: 
C 	Uwe Naumann
C	Jean Utke
C Additional contributors are: 
C	Andrew Lyons
C	Peter Fine
C
C For more details about xaifBooster and its use in OpenAD please visit:
C   http://www.mcs.anl.gov/openad
C
C This work is partially supported by:
C 	NSF-ITR grant OCE-0205590
C ========== end copyright notice ==============

      SUBROUTINE head(OBJ, G_OBJ0, G_OBJ1, G_OBJ2, G_OBJ3, G_OBJ4,
     >  G_OBJ5, X0, X1, X2, X3, X4, X5, H_OBJ0, H_OBJ1, H_OBJ2, H_OBJ3,
     >  H_OBJ4, H_OBJ5, H_OBJ6, H_OBJ7, H_OBJ8, H_OBJ9, H_OBJ10,
     >  H_OBJ11, H_OBJ12, H_OBJ13, H_OBJ14, H_OBJ15, H_OBJ16, H_OBJ17,
     >  H_OBJ18, H_OBJ19, H_OBJ20)
          use OAD_tape
          use OAD_rev
          use OAD_cp

          ! original arguments get inserted before version
          ! and declared here together with all local variables
          ! generated by xaifBooster

      use w2f__types
      use OAD_active
      IMPLICIT NONE
C
C     **** Global Variables & Derived Type Definitions ****
C
      REAL(w2f__8) OpenAD_Symbol_0
      REAL(w2f__8) OpenAD_Symbol_10
      REAL(w2f__8) OpenAD_Symbol_100
      REAL(w2f__8) OpenAD_Symbol_101
      REAL(w2f__8) OpenAD_Symbol_103
      REAL(w2f__8) OpenAD_Symbol_105
      REAL(w2f__8) OpenAD_Symbol_106
      REAL(w2f__8) OpenAD_Symbol_107
      REAL(w2f__8) OpenAD_Symbol_108
      REAL(w2f__8) OpenAD_Symbol_11
      REAL(w2f__8) OpenAD_Symbol_111
      REAL(w2f__8) OpenAD_Symbol_112
      REAL(w2f__8) OpenAD_Symbol_114
      REAL(w2f__8) OpenAD_Symbol_116
      REAL(w2f__8) OpenAD_Symbol_117
      REAL(w2f__8) OpenAD_Symbol_118
      REAL(w2f__8) OpenAD_Symbol_119
      REAL(w2f__8) OpenAD_Symbol_122
      REAL(w2f__8) OpenAD_Symbol_123
      REAL(w2f__8) OpenAD_Symbol_124
      REAL(w2f__8) OpenAD_Symbol_125
      REAL(w2f__8) OpenAD_Symbol_126
      REAL(w2f__8) OpenAD_Symbol_127
      REAL(w2f__8) OpenAD_Symbol_128
      REAL(w2f__8) OpenAD_Symbol_129
      REAL(w2f__8) OpenAD_Symbol_130
      REAL(w2f__8) OpenAD_Symbol_131
      REAL(w2f__8) OpenAD_Symbol_132
      REAL(w2f__8) OpenAD_Symbol_133
      REAL(w2f__8) OpenAD_Symbol_134
      REAL(w2f__8) OpenAD_Symbol_135
      REAL(w2f__8) OpenAD_Symbol_136
      REAL(w2f__8) OpenAD_Symbol_137
      REAL(w2f__8) OpenAD_Symbol_138
      REAL(w2f__8) OpenAD_Symbol_14
      REAL(w2f__8) OpenAD_Symbol_140
      REAL(w2f__8) OpenAD_Symbol_142
      REAL(w2f__8) OpenAD_Symbol_146
      REAL(w2f__8) OpenAD_Symbol_147
      REAL(w2f__8) OpenAD_Symbol_149
      REAL(w2f__8) OpenAD_Symbol_15
      REAL(w2f__8) OpenAD_Symbol_150
      REAL(w2f__8) OpenAD_Symbol_152
      REAL(w2f__8) OpenAD_Symbol_154
      REAL(w2f__8) OpenAD_Symbol_155
      REAL(w2f__8) OpenAD_Symbol_156
      REAL(w2f__8) OpenAD_Symbol_157
      REAL(w2f__8) OpenAD_Symbol_158
      REAL(w2f__8) OpenAD_Symbol_159
      REAL(w2f__8) OpenAD_Symbol_16
      REAL(w2f__8) OpenAD_Symbol_160
      REAL(w2f__8) OpenAD_Symbol_161
      type(active) :: OpenAD_Symbol_162
      type(active) :: OpenAD_Symbol_163
      REAL(w2f__8) OpenAD_Symbol_164
      REAL(w2f__8) OpenAD_Symbol_165
      REAL(w2f__8) OpenAD_Symbol_166
      REAL(w2f__8) OpenAD_Symbol_167
      REAL(w2f__8) OpenAD_Symbol_168
      REAL(w2f__8) OpenAD_Symbol_169
      REAL(w2f__8) OpenAD_Symbol_17
      REAL(w2f__8) OpenAD_Symbol_170
      REAL(w2f__8) OpenAD_Symbol_171
      type(active) :: OpenAD_Symbol_172
      type(active) :: OpenAD_Symbol_173
      type(active) :: OpenAD_Symbol_174
      type(active) :: OpenAD_Symbol_175
      REAL(w2f__8) OpenAD_Symbol_176
      type(active) :: OpenAD_Symbol_177
      REAL(w2f__8) OpenAD_Symbol_178
      REAL(w2f__8) OpenAD_Symbol_179
      REAL(w2f__8) OpenAD_Symbol_18
      type(active) :: OpenAD_Symbol_180
      type(active) :: OpenAD_Symbol_181
      type(active) :: OpenAD_Symbol_182
      type(active) :: OpenAD_Symbol_183
      type(active) :: OpenAD_Symbol_184
      REAL(w2f__8) OpenAD_Symbol_19
      REAL(w2f__8) OpenAD_Symbol_2
      REAL(w2f__8) OpenAD_Symbol_20
      REAL(w2f__8) OpenAD_Symbol_21
      REAL(w2f__8) OpenAD_Symbol_22
      REAL(w2f__8) OpenAD_Symbol_23
      REAL(w2f__8) OpenAD_Symbol_24
      REAL(w2f__8) OpenAD_Symbol_25
      REAL(w2f__8) OpenAD_Symbol_26
      REAL(w2f__8) OpenAD_Symbol_28
      REAL(w2f__8) OpenAD_Symbol_30
      REAL(w2f__8) OpenAD_Symbol_31
      REAL(w2f__8) OpenAD_Symbol_32
      REAL(w2f__8) OpenAD_Symbol_33
      REAL(w2f__8) OpenAD_Symbol_35
      REAL(w2f__8) OpenAD_Symbol_36
      REAL(w2f__8) OpenAD_Symbol_38
      REAL(w2f__8) OpenAD_Symbol_39
      REAL(w2f__8) OpenAD_Symbol_4
      REAL(w2f__8) OpenAD_Symbol_40
      REAL(w2f__8) OpenAD_Symbol_41
      REAL(w2f__8) OpenAD_Symbol_42
      REAL(w2f__8) OpenAD_Symbol_44
      REAL(w2f__8) OpenAD_Symbol_45
      REAL(w2f__8) OpenAD_Symbol_47
      REAL(w2f__8) OpenAD_Symbol_48
      REAL(w2f__8) OpenAD_Symbol_49
      REAL(w2f__8) OpenAD_Symbol_50
      REAL(w2f__8) OpenAD_Symbol_51
      REAL(w2f__8) OpenAD_Symbol_52
      REAL(w2f__8) OpenAD_Symbol_53
      REAL(w2f__8) OpenAD_Symbol_54
      REAL(w2f__8) OpenAD_Symbol_56
      REAL(w2f__8) OpenAD_Symbol_57
      REAL(w2f__8) OpenAD_Symbol_58
      REAL(w2f__8) OpenAD_Symbol_59
      REAL(w2f__8) OpenAD_Symbol_6
      REAL(w2f__8) OpenAD_Symbol_60
      REAL(w2f__8) OpenAD_Symbol_61
      REAL(w2f__8) OpenAD_Symbol_62
      REAL(w2f__8) OpenAD_Symbol_63
      REAL(w2f__8) OpenAD_Symbol_64
      REAL(w2f__8) OpenAD_Symbol_65
      REAL(w2f__8) OpenAD_Symbol_66
      REAL(w2f__8) OpenAD_Symbol_67
      REAL(w2f__8) OpenAD_Symbol_68
      REAL(w2f__8) OpenAD_Symbol_69
      REAL(w2f__8) OpenAD_Symbol_70
      REAL(w2f__8) OpenAD_Symbol_71
      REAL(w2f__8) OpenAD_Symbol_72
      REAL(w2f__8) OpenAD_Symbol_75
      REAL(w2f__8) OpenAD_Symbol_79
      REAL(w2f__8) OpenAD_Symbol_8
      REAL(w2f__8) OpenAD_Symbol_80
      REAL(w2f__8) OpenAD_Symbol_81
      REAL(w2f__8) OpenAD_Symbol_82
      REAL(w2f__8) OpenAD_Symbol_83
      REAL(w2f__8) OpenAD_Symbol_84
      REAL(w2f__8) OpenAD_Symbol_85
      REAL(w2f__8) OpenAD_Symbol_86
      REAL(w2f__8) OpenAD_Symbol_87
      REAL(w2f__8) OpenAD_Symbol_88
      REAL(w2f__8) OpenAD_Symbol_89
      REAL(w2f__8) OpenAD_Symbol_9
      REAL(w2f__8) OpenAD_Symbol_90
      REAL(w2f__8) OpenAD_Symbol_91
      REAL(w2f__8) OpenAD_Symbol_92
      REAL(w2f__8) OpenAD_Symbol_93
      REAL(w2f__8) OpenAD_Symbol_94
      REAL(w2f__8) OpenAD_Symbol_95
      REAL(w2f__8) OpenAD_Symbol_96
      REAL(w2f__8) OpenAD_Symbol_97
      REAL(w2f__8) OpenAD_Symbol_98
      REAL(w2f__8) OpenAD_Symbol_99
C
C     **** Parameters and Result ****
C
      type(active) :: OBJ
      type(active) :: G_OBJ0
      type(active) :: G_OBJ1
      type(active) :: G_OBJ2
      type(active) :: G_OBJ3
      type(active) :: G_OBJ4
      type(active) :: G_OBJ5
      type(active) :: X0
      type(active) :: X1
      type(active) :: X2
      type(active) :: X3
      type(active) :: X4
      type(active) :: X5
      type(active) :: H_OBJ0
      type(active) :: H_OBJ1
      type(active) :: H_OBJ2
      type(active) :: H_OBJ3
      type(active) :: H_OBJ4
      type(active) :: H_OBJ5
      type(active) :: H_OBJ6
      type(active) :: H_OBJ7
      type(active) :: H_OBJ8
      type(active) :: H_OBJ9
      type(active) :: H_OBJ10
      type(active) :: H_OBJ11
      type(active) :: H_OBJ12
      type(active) :: H_OBJ13
      type(active) :: H_OBJ14
      type(active) :: H_OBJ15
      type(active) :: H_OBJ16
      type(active) :: H_OBJ17
      type(active) :: H_OBJ18
      type(active) :: H_OBJ19
      type(active) :: H_OBJ20
C
C     **** Local Variables and Functions ****
C
      REAL(w2f__8) A
      REAL(w2f__8) AB
      type(active) :: ADJ_M0
      type(active) :: ADJ_M1
      type(active) :: ADJ_M2
      type(active) :: ADJ_M3
      REAL(w2f__8) B
      REAL(w2f__8) BM1
      type(active) :: D00
      type(active) :: D01
      type(active) :: D03
      type(active) :: D11
      type(active) :: D12
      type(active) :: F
      REAL(w2f__8) FOUR3RD
      type(active) :: G
      type(active) :: GG
      type(active) :: LOC1
      type(active) :: LOC2
      type(active) :: M00
      type(active) :: M01
      type(active) :: M02
      type(active) :: M03
      type(active) :: M11
      type(active) :: M12
      type(active) :: M13
      type(active) :: M22
      type(active) :: M23
      type(active) :: M33
      type(active) :: MATR0
      type(active) :: MATR1
      type(active) :: MATR2
      type(active) :: MATR3
      REAL(w2f__8) NORM
      type(active) :: R00
      type(active) :: R02
      type(active) :: R03
      type(active) :: R11
      type(active) :: R12
      type(active) :: R13
      REAL(w2f__8) R22
      REAL(w2f__8) R33
      REAL(w2f__8) SQRT3
      REAL(w2f__8) THIRD
      REAL(w2f__8) TSQRT3
      REAL(w2f__8) TWO3RD
      REAL(w2f__8) TWOSQRT3
      REAL(w2f__8) OpenAD_Symbol_185
      REAL(w2f__8) OpenAD_Symbol_186
      REAL(w2f__8) OpenAD_Symbol_187
      REAL(w2f__8) OpenAD_Symbol_188
      REAL(w2f__8) OpenAD_Symbol_189
      REAL(w2f__8) OpenAD_Symbol_190
      REAL(w2f__8) OpenAD_Symbol_191
      REAL(w2f__8) OpenAD_Symbol_192
      REAL(w2f__8) OpenAD_Symbol_193
      REAL(w2f__8) OpenAD_Symbol_194
      REAL(w2f__8) OpenAD_Symbol_195
      REAL(w2f__8) OpenAD_Symbol_196
      REAL(w2f__8) OpenAD_Symbol_197
      REAL(w2f__8) OpenAD_Symbol_198
      REAL(w2f__8) OpenAD_Symbol_199
      REAL(w2f__8) OpenAD_Symbol_200
      REAL(w2f__8) OpenAD_Symbol_201
      REAL(w2f__8) OpenAD_Symbol_202
      REAL(w2f__8) OpenAD_Symbol_203
      REAL(w2f__8) OpenAD_Symbol_204
      REAL(w2f__8) OpenAD_Symbol_205
      REAL(w2f__8) OpenAD_Symbol_206
      REAL(w2f__8) OpenAD_Symbol_207
      REAL(w2f__8) OpenAD_Symbol_208
      REAL(w2f__8) OpenAD_Symbol_209
      REAL(w2f__8) OpenAD_Symbol_210
      REAL(w2f__8) OpenAD_Symbol_211
      REAL(w2f__8) OpenAD_Symbol_212
      REAL(w2f__8) OpenAD_Symbol_213
      REAL(w2f__8) OpenAD_Symbol_214
      REAL(w2f__8) OpenAD_Symbol_215
      REAL(w2f__8) OpenAD_Symbol_216
      REAL(w2f__8) OpenAD_Symbol_217
      REAL(w2f__8) OpenAD_Symbol_218
      REAL(w2f__8) OpenAD_Symbol_219
      REAL(w2f__8) OpenAD_Symbol_220
      REAL(w2f__8) OpenAD_Symbol_221
      REAL(w2f__8) OpenAD_Symbol_222
      REAL(w2f__8) OpenAD_Symbol_223
      REAL(w2f__8) OpenAD_Symbol_224
      REAL(w2f__8) OpenAD_Symbol_225
      REAL(w2f__8) OpenAD_Symbol_226
      REAL(w2f__8) OpenAD_Symbol_227
      REAL(w2f__8) OpenAD_Symbol_228
      REAL(w2f__8) OpenAD_Symbol_229
      REAL(w2f__8) OpenAD_Symbol_230
      REAL(w2f__8) OpenAD_Symbol_231
      REAL(w2f__8) OpenAD_Symbol_232
      REAL(w2f__8) OpenAD_Symbol_233
      REAL(w2f__8) OpenAD_Symbol_234
      REAL(w2f__8) OpenAD_Symbol_235
      REAL(w2f__8) OpenAD_Symbol_236
      REAL(w2f__8) OpenAD_Symbol_237
      REAL(w2f__8) OpenAD_Symbol_238
      REAL(w2f__8) OpenAD_Symbol_239
      REAL(w2f__8) OpenAD_Symbol_240
      REAL(w2f__8) OpenAD_Symbol_241
      REAL(w2f__8) OpenAD_Symbol_242
      REAL(w2f__8) OpenAD_Symbol_243
      REAL(w2f__8) OpenAD_Symbol_244
      REAL(w2f__8) OpenAD_Symbol_245
      REAL(w2f__8) OpenAD_Symbol_246
      REAL(w2f__8) OpenAD_Symbol_247
      REAL(w2f__8) OpenAD_Symbol_248
      REAL(w2f__8) OpenAD_Symbol_249
      REAL(w2f__8) OpenAD_Symbol_250
      REAL(w2f__8) OpenAD_Symbol_251
      REAL(w2f__8) OpenAD_Symbol_252
      REAL(w2f__8) OpenAD_Symbol_253
      REAL(w2f__8) OpenAD_Symbol_254
      REAL(w2f__8) OpenAD_Symbol_255
      REAL(w2f__8) OpenAD_Symbol_256
      REAL(w2f__8) OpenAD_Symbol_257
      REAL(w2f__8) OpenAD_Symbol_258
      REAL(w2f__8) OpenAD_Symbol_259
      REAL(w2f__8) OpenAD_Symbol_260
      REAL(w2f__8) OpenAD_Symbol_261
      REAL(w2f__8) OpenAD_Symbol_262
      REAL(w2f__8) OpenAD_Symbol_263
      REAL(w2f__8) OpenAD_Symbol_264
      REAL(w2f__8) OpenAD_Symbol_265
      REAL(w2f__8) OpenAD_Symbol_266
      REAL(w2f__8) OpenAD_Symbol_267
      REAL(w2f__8) OpenAD_Symbol_268
      REAL(w2f__8) OpenAD_Symbol_269
      REAL(w2f__8) OpenAD_Symbol_270
      REAL(w2f__8) OpenAD_Symbol_271
      REAL(w2f__8) OpenAD_Symbol_272
      REAL(w2f__8) OpenAD_Symbol_273
      REAL(w2f__8) OpenAD_Symbol_274
      REAL(w2f__8) OpenAD_Symbol_275
      REAL(w2f__8) OpenAD_Symbol_276


          ! checkpointing stacks and offsets
          integer :: cp_loop_variable_1,cp_loop_variable_2,
     +cp_loop_variable_3,cp_loop_variable_4,cp_loop_variable_5
          ! floats 'F'
          double precision, dimension(:), allocatable, save :: 
     +theArgFStack
          integer, save :: theArgFStackoffset=0, theArgFStackSize=0
          ! integers 'I'
          integer, dimension(:), allocatable, save :: 
     +theArgIStack
          integer, save :: theArgIStackoffset=0, theArgIStackSize=0
          ! booleans 'B'
          logical, dimension(:), allocatable, save :: 
     +theArgBStack
          integer, save :: theArgBStackoffset=0, theArgBStackSize=0
          ! strings 'S'
          character*(80), dimension(:), allocatable, save :: 
     +theArgSStack
          integer, save :: theArgSStackoffset=0, theArgSStackSize=0

          type(modeType) :: our_orig_mode

! external C function used in inlined code
          integer iaddr
          external iaddr
C
C     **** Top Level Pragmas ****
C
C$OPENAD INDEPENDENT(X0)
C$OPENAD INDEPENDENT(X1)
C$OPENAD INDEPENDENT(X2)
C$OPENAD INDEPENDENT(X3)
C$OPENAD INDEPENDENT(X4)
C$OPENAD INDEPENDENT(X5)
C$OPENAD DEPENDENT(OBJ)
C$OPENAD DEPENDENT(G_OBJ0)
C$OPENAD DEPENDENT(G_OBJ1)
C$OPENAD DEPENDENT(G_OBJ2)
C$OPENAD DEPENDENT(G_OBJ3)
C$OPENAD DEPENDENT(G_OBJ4)
C$OPENAD DEPENDENT(G_OBJ5)
C$OPENAD DEPENDENT(H_OBJ0)
C$OPENAD DEPENDENT(H_OBJ1)
C$OPENAD DEPENDENT(H_OBJ2)
C$OPENAD DEPENDENT(H_OBJ3)
C$OPENAD DEPENDENT(H_OBJ4)
C$OPENAD DEPENDENT(H_OBJ5)
C$OPENAD DEPENDENT(H_OBJ6)
C$OPENAD DEPENDENT(H_OBJ7)
C$OPENAD DEPENDENT(H_OBJ8)
C$OPENAD DEPENDENT(H_OBJ9)
C$OPENAD DEPENDENT(H_OBJ10)
C$OPENAD DEPENDENT(H_OBJ11)
C$OPENAD DEPENDENT(H_OBJ12)
C$OPENAD DEPENDENT(H_OBJ13)
C$OPENAD DEPENDENT(H_OBJ14)
C$OPENAD DEPENDENT(H_OBJ15)
C$OPENAD DEPENDENT(H_OBJ16)
C$OPENAD DEPENDENT(H_OBJ17)
C$OPENAD DEPENDENT(H_OBJ18)
C$OPENAD DEPENDENT(H_OBJ19)
C$OPENAD DEPENDENT(H_OBJ20)
C
C     **** Statements ****
C

          if (our_rev_mode%arg_store) then 
C store arguments

          end if 
          if (our_rev_mode%arg_restore) then
C restore arguments

          end if
          if (our_rev_mode%plain) then
            our_orig_mode=our_rev_mode
            our_rev_mode%arg_store=.FALSE.
C original function
C$OPENAD XXX Template ad_template.f
      A = 5.0D-01
      B = (-1.0D00)
      AB = (A * B)
      SQRT3 = 5.77350258827209472656D-01
      TSQRT3 = 1.15470051765441894531D00
      TWOSQRT3 = 1.15470051765441894531D00
      THIRD = 3.33333343267440795898D-01
      TWO3RD = 6.66666686534881591797D-01
      FOUR3RD = 1.33333337306976318359D00
      BM1 = (-2.0D00)
      MATR0%v = (X1%v-X0%v)
      MATR1%v = (SQRT3*(X2%v*2.0D00-X1%v-X0%v))
      MATR2%v = (X4%v-X3%v)
      MATR3%v = (SQRT3*(X5%v*2.0D00-X4%v-X3%v))
      M03%v = (MATR0%v*MATR3%v)
      M12%v = (MATR1%v*MATR2%v)
      G%v = (M03%v-M12%v)
      D00%v = (M03%v*2.0D00)
      D11%v = (M12%v*2.0D00)
      M00%v = (MATR0%v*MATR0%v)
      M11%v = (MATR1%v*MATR1%v)
      M22%v = (MATR2%v*MATR2%v)
      M33%v = (MATR3%v*MATR3%v)
      D12%v = (M00%v*M33%v)
      D03%v = (M11%v*M22%v)
      F%v = (D03%v+D12%v)
      NORM = F%v
      LOC1%v = (A*(1.0D00/G%v))
      OBJ%v = (F%v*LOC1%v)
      LOC2%v = (AB*(1.0D00/(G%v*G%v)))
      GG%v = (AB*B*(1.0D00/(G%v*G%v*G%v)))
      G%v = (F%v*LOC2%v)
      F%v = (LOC1%v*2.0D00)
      ADJ_M0%v = (F%v*MATR0%v+G%v*MATR3%v)
      ADJ_M1%v = (F%v*MATR1%v-G%v*MATR2%v)
      ADJ_M2%v = (F%v*MATR2%v-G%v*MATR1%v)
      ADJ_M3%v = (F%v*MATR3%v+G%v*MATR0%v)
      LOC1%v = (ADJ_M1%v*SQRT3)
      G_OBJ0%v = (-(ADJ_M0%v+LOC1%v))
      G_OBJ1%v = (ADJ_M0%v-LOC1%v)
      G_OBJ2%v = (LOC1%v*2.0D00)
      LOC1%v = (ADJ_M3%v*SQRT3)
      G_OBJ3%v = (-(ADJ_M2%v+LOC1%v))
      G_OBJ4%v = (ADJ_M2%v-LOC1%v)
      G_OBJ5%v = (LOC1%v*2.0D00)
      LOC2%v = (LOC2%v*2.0D00)
      R00%v = (D00%v*LOC2%v+GG%v*M33%v)
      R11%v = (D11%v*LOC2%v+GG%v*M22%v)
      R22 = (D11%v*LOC2%v+GG%v*M11%v)
      R33 = (D00%v*LOC2%v+GG%v*M00%v)
      M01%v = (MATR0%v*MATR1%v)
      M02%v = (MATR0%v*MATR2%v)
      M12%v = (MATR1%v*MATR2%v)
      M13%v = (MATR1%v*MATR3%v)
      M23%v = (MATR2%v*MATR3%v)
      D01%v = (LOC2%v*(M02%v+M13%v))
      LOC1%v = (R11%v*THIRD)
      F%v = (TWOSQRT3*(D01%v+GG%v*M23%v))
      G%v = (LOC1%v+R00%v)
      H_OBJ1%v = (LOC1%v-R00%v)
      H_OBJ0%v = (F%v+G%v)
      H_OBJ3%v = (G%v-F%v)
      LOC1%v = (-(R11%v*TWO3RD))
      H_OBJ2%v = (LOC1%v-F%v)
      H_OBJ4%v = (F%v+LOC1%v)
      H_OBJ5%v = (FOUR3RD*R11%v)
      LOC1%v = (R00%v*THIRD)
      F%v = (TWOSQRT3*(D01%v+GG%v*M01%v))
      G%v = (LOC1%v+R11%v)
      H_OBJ16%v = (LOC1%v-R11%v)
      H_OBJ15%v = (F%v+G%v)
      H_OBJ18%v = (G%v-F%v)
      LOC1%v = (-(R00%v*TWO3RD))
      H_OBJ17%v = (LOC1%v-F%v)
      H_OBJ19%v = (F%v+LOC1%v)
      H_OBJ20%v = (FOUR3RD*R00%v)
      LOC1%v = (LOC2%v*(M01%v+M23%v))
      R13%v = (LOC1%v+GG%v*M02%v)
      R02%v = (LOC1%v+GG%v*M13%v)
      R03%v = (D03%v*LOC2%v+GG%v*M03%v)
      R12%v = (D12%v*LOC2%v+GG%v*M12%v)
      G%v = (-(R13%v*TWO3RD))
      F%v = (R03%v*TWOSQRT3)
      H_OBJ8%v = (G%v-F%v)
      H_OBJ11%v = (F%v+G%v)
      F%v = (R12%v*TWOSQRT3)
      H_OBJ12%v = (G%v-F%v)
      H_OBJ13%v = (F%v+G%v)
      H_OBJ14%v = (R13%v*1.2D+01)
      G%v = (FOUR3RD*R02%v)
      F%v = (SQRT3*(R03%v+R12%v))
      H_OBJ10%v = (G%v-F%v)
      H_OBJ6%v = (F%v+G%v)
      G%v = (R02%v*TWO3RD)
      F%v = (SQRT3*(R03%v-R12%v))
      H_OBJ9%v = (G%v-F%v)
      H_OBJ7%v = (F%v+G%v)

C original function end
            our_rev_mode=our_orig_mode
          end if 
          if (our_rev_mode%tape) then
C            print*, " tape       ", our_rev_mode
            our_rev_mode%arg_store=.TRUE.
            our_rev_mode%arg_restore=.FALSE.
            our_rev_mode%plain=.TRUE.
            our_rev_mode%tape=.FALSE.
            our_rev_mode%adjoint=.FALSE.
C taping
C$OPENAD XXX Template ad_template.f
      A = 5.0D-01
      B = (-1.0D00)
      AB = (A * B)
      SQRT3 = 5.77350258827209472656D-01
      TSQRT3 = 1.15470051765441894531D00
      TWOSQRT3 = 1.15470051765441894531D00
      THIRD = 3.33333343267440795898D-01
      TWO3RD = 6.66666686534881591797D-01
      FOUR3RD = 1.33333337306976318359D00
      BM1 = (-2.0D00)
      MATR0%v = (X1%v-X0%v)
      OpenAD_Symbol_0 = (X2%v*2.0D00-X1%v-X0%v)
      MATR1%v = (SQRT3*OpenAD_Symbol_0)
      OpenAD_Symbol_2 = SQRT3
      MATR2%v = (X4%v-X3%v)
      OpenAD_Symbol_4 = (X5%v*2.0D00-X4%v-X3%v)
      MATR3%v = (SQRT3*OpenAD_Symbol_4)
      OpenAD_Symbol_6 = SQRT3
      M03%v = (MATR0%v*MATR3%v)
      OpenAD_Symbol_8 = MATR3%v
      OpenAD_Symbol_9 = MATR0%v
      M12%v = (MATR1%v*MATR2%v)
      OpenAD_Symbol_10 = MATR2%v
      OpenAD_Symbol_11 = MATR1%v
      G%v = (M03%v-M12%v)
      D00%v = (M03%v*2.0D00)
      D11%v = (M12%v*2.0D00)
      M00%v = (MATR0%v*MATR0%v)
      OpenAD_Symbol_14 = MATR0%v
      OpenAD_Symbol_15 = MATR0%v
      M11%v = (MATR1%v*MATR1%v)
      OpenAD_Symbol_16 = MATR1%v
      OpenAD_Symbol_17 = MATR1%v
      M22%v = (MATR2%v*MATR2%v)
      OpenAD_Symbol_18 = MATR2%v
      OpenAD_Symbol_19 = MATR2%v
      M33%v = (MATR3%v*MATR3%v)
      OpenAD_Symbol_20 = MATR3%v
      OpenAD_Symbol_21 = MATR3%v
      D12%v = (M00%v*M33%v)
      OpenAD_Symbol_22 = M33%v
      OpenAD_Symbol_23 = M00%v
      D03%v = (M11%v*M22%v)
      OpenAD_Symbol_24 = M22%v
      OpenAD_Symbol_25 = M11%v
      F%v = (D03%v+D12%v)
      NORM = F%v
      OpenAD_Symbol_26 = (1.0D00/G%v)
      LOC1%v = (A*OpenAD_Symbol_26)
      OpenAD_Symbol_30 = (-(1.0D00/(G%v*G%v)))
      OpenAD_Symbol_28 = A
      OBJ%v = (F%v*LOC1%v)
      OpenAD_Symbol_31 = LOC1%v
      OpenAD_Symbol_32 = F%v
      OpenAD_Symbol_36 = (G%v*G%v)
      OpenAD_Symbol_33 = (1.0D00 / OpenAD_Symbol_36)
      LOC2%v = (AB*OpenAD_Symbol_33)
      OpenAD_Symbol_39 = G%v
      OpenAD_Symbol_40 = G%v
      OpenAD_Symbol_38 = (-(1.0D00 /(OpenAD_Symbol_36 *
     >  OpenAD_Symbol_36)))
      OpenAD_Symbol_35 = AB
      OpenAD_Symbol_41 = (AB * B)
      OpenAD_Symbol_48 = (G%v*G%v)
      OpenAD_Symbol_45 = (G%v*OpenAD_Symbol_48)
      OpenAD_Symbol_42 = (1.0D00 / OpenAD_Symbol_45)
      GG%v = (OpenAD_Symbol_41*OpenAD_Symbol_42)
      OpenAD_Symbol_49 = OpenAD_Symbol_48
      OpenAD_Symbol_51 = G%v
      OpenAD_Symbol_52 = G%v
      OpenAD_Symbol_50 = G%v
      OpenAD_Symbol_47 = (-(1.0D00 /(OpenAD_Symbol_45 *
     >  OpenAD_Symbol_45)))
      OpenAD_Symbol_44 = OpenAD_Symbol_41
      OpenAD_Symbol_155 = (OpenAD_Symbol_30 * OpenAD_Symbol_28)
      OpenAD_Symbol_156 = (OpenAD_Symbol_14 + OpenAD_Symbol_15)
      OpenAD_Symbol_157 = (OpenAD_Symbol_16 + OpenAD_Symbol_17)
      OpenAD_Symbol_158 = (OpenAD_Symbol_18 + OpenAD_Symbol_19)
      OpenAD_Symbol_159 = (OpenAD_Symbol_20 + OpenAD_Symbol_21)
      OpenAD_Symbol_160 = ((OpenAD_Symbol_49 +(OpenAD_Symbol_51 +
     >  OpenAD_Symbol_52) * OpenAD_Symbol_50) * OpenAD_Symbol_47 *
     >  OpenAD_Symbol_44)
      OpenAD_Symbol_161 = ((OpenAD_Symbol_39 + OpenAD_Symbol_40) *
     >  OpenAD_Symbol_38 * OpenAD_Symbol_35)
          double_tape(double_tape_pointer) = OpenAD_Symbol_156
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_158
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_2
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_6
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_8
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_9
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_10
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_11
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_157
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_159
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_22
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_23
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_24
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_25
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_155
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_31
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_32
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_161
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_160
          double_tape_pointer = double_tape_pointer+1
      G%v = (F%v*LOC2%v)
      OpenAD_Symbol_53 = LOC2%v
      OpenAD_Symbol_54 = F%v
      F%v = (LOC1%v*2.0D00)
      ADJ_M0%v = (F%v*MATR0%v+G%v*MATR3%v)
      OpenAD_Symbol_56 = MATR0%v
      OpenAD_Symbol_57 = F%v
      OpenAD_Symbol_58 = MATR3%v
      OpenAD_Symbol_59 = G%v
      ADJ_M1%v = (F%v*MATR1%v-G%v*MATR2%v)
      OpenAD_Symbol_60 = MATR1%v
      OpenAD_Symbol_61 = F%v
      OpenAD_Symbol_62 = MATR2%v
      OpenAD_Symbol_63 = G%v
      ADJ_M2%v = (F%v*MATR2%v-G%v*MATR1%v)
      OpenAD_Symbol_64 = MATR2%v
      OpenAD_Symbol_65 = F%v
      OpenAD_Symbol_66 = MATR1%v
      OpenAD_Symbol_67 = G%v
      ADJ_M3%v = (F%v*MATR3%v+G%v*MATR0%v)
      OpenAD_Symbol_68 = MATR3%v
      OpenAD_Symbol_69 = F%v
      OpenAD_Symbol_70 = MATR0%v
      OpenAD_Symbol_71 = G%v
      LOC1%v = (ADJ_M1%v*SQRT3)
      OpenAD_Symbol_72 = SQRT3
      G_OBJ0%v = (-(ADJ_M0%v+LOC1%v))
      G_OBJ1%v = (ADJ_M0%v-LOC1%v)
      G_OBJ2%v = (LOC1%v*2.0D00)
      OpenAD_Symbol_164 = (2.0D00 * OpenAD_Symbol_56)
      OpenAD_Symbol_165 = (2.0D00 * OpenAD_Symbol_60)
      OpenAD_Symbol_166 = (OpenAD_Symbol_62 * INT((-1_w2f__i8)))
      OpenAD_Symbol_167 = (OpenAD_Symbol_63 * INT((-1_w2f__i8)))
      OpenAD_Symbol_168 = (2.0D00 * OpenAD_Symbol_64)
      OpenAD_Symbol_169 = (OpenAD_Symbol_66 * INT((-1_w2f__i8)))
      OpenAD_Symbol_170 = (OpenAD_Symbol_67 * INT((-1_w2f__i8)))
      OpenAD_Symbol_171 = (2.0D00 * OpenAD_Symbol_68)
          double_tape(double_tape_pointer) = OpenAD_Symbol_53
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_54
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_57
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_164
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_58
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_59
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_61
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_165
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_166
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_167
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_65
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_168
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_169
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_170
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_69
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_171
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_70
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_71
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_72
          double_tape_pointer = double_tape_pointer+1
      LOC1%v = (ADJ_M3%v*SQRT3)
      OpenAD_Symbol_75 = SQRT3
      G_OBJ3%v = (-(ADJ_M2%v+LOC1%v))
      G_OBJ4%v = (ADJ_M2%v-LOC1%v)
      G_OBJ5%v = (LOC1%v*2.0D00)
      OpenAD_Symbol_79 = (LOC2%v*2.0D00)
      LOC2%v = OpenAD_Symbol_79
      R00%v = (D00%v*LOC2%v+GG%v*M33%v)
      OpenAD_Symbol_80 = LOC2%v
      OpenAD_Symbol_81 = D00%v
      OpenAD_Symbol_82 = M33%v
      OpenAD_Symbol_83 = GG%v
      R11%v = (D11%v*LOC2%v+GG%v*M22%v)
      OpenAD_Symbol_84 = LOC2%v
      OpenAD_Symbol_85 = D11%v
      OpenAD_Symbol_86 = M22%v
      OpenAD_Symbol_87 = GG%v
      R22 = (D11%v*LOC2%v+GG%v*M11%v)
      R33 = (D00%v*LOC2%v+GG%v*M00%v)
      M01%v = (MATR0%v*MATR1%v)
      OpenAD_Symbol_88 = MATR1%v
      OpenAD_Symbol_89 = MATR0%v
      M02%v = (MATR0%v*MATR2%v)
      OpenAD_Symbol_90 = MATR2%v
      OpenAD_Symbol_91 = MATR0%v
      M12%v = (MATR1%v*MATR2%v)
      OpenAD_Symbol_92 = MATR2%v
      OpenAD_Symbol_93 = MATR1%v
      M13%v = (MATR1%v*MATR3%v)
      OpenAD_Symbol_94 = MATR3%v
      OpenAD_Symbol_95 = MATR1%v
      M23%v = (MATR2%v*MATR3%v)
      OpenAD_Symbol_96 = MATR3%v
      OpenAD_Symbol_97 = MATR2%v
      OpenAD_Symbol_98 = (M02%v+M13%v)
      D01%v = (LOC2%v*OpenAD_Symbol_98)
      OpenAD_Symbol_99 = OpenAD_Symbol_98
      OpenAD_Symbol_100 = LOC2%v
          double_tape(double_tape_pointer) = OpenAD_Symbol_75
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_88
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_89
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_90
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_91
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_92
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_93
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_94
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_95
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_96
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_97
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_80
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_81
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_82
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_83
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_84
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_85
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_86
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_87
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_99
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_100
          double_tape_pointer = double_tape_pointer+1
      LOC1%v = (R11%v*THIRD)
      OpenAD_Symbol_101 = THIRD
      OpenAD_Symbol_103 = (D01%v+GG%v*M23%v)
      F%v = (TWOSQRT3*OpenAD_Symbol_103)
      OpenAD_Symbol_106 = M23%v
      OpenAD_Symbol_107 = GG%v
      OpenAD_Symbol_105 = TWOSQRT3
      G%v = (LOC1%v+R00%v)
      H_OBJ1%v = (LOC1%v-R00%v)
      H_OBJ0%v = (F%v+G%v)
      H_OBJ3%v = (G%v-F%v)
          double_tape(double_tape_pointer) = OpenAD_Symbol_101
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_106
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_107
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_105
          double_tape_pointer = double_tape_pointer+1
      LOC1%v = (-(R11%v*TWO3RD))
      OpenAD_Symbol_108 = TWO3RD
      H_OBJ2%v = (LOC1%v-F%v)
      H_OBJ4%v = (F%v+LOC1%v)
      H_OBJ5%v = (FOUR3RD*R11%v)
      OpenAD_Symbol_111 = FOUR3RD
      OpenAD_Symbol_176 = (OpenAD_Symbol_108 * INT((-1_w2f__i8)))
          double_tape(double_tape_pointer) = OpenAD_Symbol_111
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_176
          double_tape_pointer = double_tape_pointer+1
      LOC1%v = (R00%v*THIRD)
      OpenAD_Symbol_112 = THIRD
      OpenAD_Symbol_114 = (D01%v+GG%v*M01%v)
      F%v = (TWOSQRT3*OpenAD_Symbol_114)
      OpenAD_Symbol_117 = M01%v
      OpenAD_Symbol_118 = GG%v
      OpenAD_Symbol_116 = TWOSQRT3
      G%v = (LOC1%v+R11%v)
      H_OBJ16%v = (LOC1%v-R11%v)
      H_OBJ15%v = (F%v+G%v)
      H_OBJ18%v = (G%v-F%v)
          double_tape(double_tape_pointer) = OpenAD_Symbol_112
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_117
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_118
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_116
          double_tape_pointer = double_tape_pointer+1
      LOC1%v = (-(R00%v*TWO3RD))
      OpenAD_Symbol_119 = TWO3RD
      H_OBJ17%v = (LOC1%v-F%v)
      H_OBJ19%v = (F%v+LOC1%v)
      H_OBJ20%v = (FOUR3RD*R00%v)
      OpenAD_Symbol_122 = FOUR3RD
      OpenAD_Symbol_178 = (OpenAD_Symbol_119 * INT((-1_w2f__i8)))
          double_tape(double_tape_pointer) = OpenAD_Symbol_122
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_178
          double_tape_pointer = double_tape_pointer+1
      OpenAD_Symbol_123 = (M01%v+M23%v)
      LOC1%v = (LOC2%v*OpenAD_Symbol_123)
      OpenAD_Symbol_124 = OpenAD_Symbol_123
      OpenAD_Symbol_125 = LOC2%v
      R13%v = (LOC1%v+GG%v*M02%v)
      OpenAD_Symbol_126 = M02%v
      OpenAD_Symbol_127 = GG%v
      R02%v = (LOC1%v+GG%v*M13%v)
      OpenAD_Symbol_128 = M13%v
      OpenAD_Symbol_129 = GG%v
      R03%v = (D03%v*LOC2%v+GG%v*M03%v)
      OpenAD_Symbol_130 = LOC2%v
      OpenAD_Symbol_131 = D03%v
      OpenAD_Symbol_132 = M03%v
      OpenAD_Symbol_133 = GG%v
      R12%v = (D12%v*LOC2%v+GG%v*M12%v)
      OpenAD_Symbol_134 = LOC2%v
      OpenAD_Symbol_135 = D12%v
      OpenAD_Symbol_136 = M12%v
      OpenAD_Symbol_137 = GG%v
      G%v = (-(R13%v*TWO3RD))
      OpenAD_Symbol_138 = TWO3RD
      F%v = (R03%v*TWOSQRT3)
      OpenAD_Symbol_140 = TWOSQRT3
      H_OBJ8%v = (G%v-F%v)
      H_OBJ11%v = (F%v+G%v)
      OpenAD_Symbol_179 = (OpenAD_Symbol_138 * INT((-1_w2f__i8)))
          double_tape(double_tape_pointer) = OpenAD_Symbol_124
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_125
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_126
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_127
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_128
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_129
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_130
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_131
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_132
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_133
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_134
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_135
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_136
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_137
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_140
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_179
          double_tape_pointer = double_tape_pointer+1
      F%v = (R12%v*TWOSQRT3)
      OpenAD_Symbol_142 = TWOSQRT3
      H_OBJ12%v = (G%v-F%v)
      H_OBJ13%v = (F%v+G%v)
      H_OBJ14%v = (R13%v*1.2D+01)
      G%v = (FOUR3RD*R02%v)
      OpenAD_Symbol_146 = FOUR3RD
          double_tape(double_tape_pointer) = OpenAD_Symbol_142
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_146
          double_tape_pointer = double_tape_pointer+1
      OpenAD_Symbol_147 = (R03%v+R12%v)
      F%v = (SQRT3*OpenAD_Symbol_147)
      OpenAD_Symbol_149 = SQRT3
      H_OBJ10%v = (G%v-F%v)
      H_OBJ6%v = (F%v+G%v)
      G%v = (R02%v*TWO3RD)
      OpenAD_Symbol_150 = TWO3RD
          double_tape(double_tape_pointer) = OpenAD_Symbol_150
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_Symbol_149
          double_tape_pointer = double_tape_pointer+1
      OpenAD_Symbol_152 = (R03%v-R12%v)
      F%v = (SQRT3*OpenAD_Symbol_152)
      OpenAD_Symbol_154 = SQRT3
      H_OBJ9%v = (G%v-F%v)
      H_OBJ7%v = (F%v+G%v)
          double_tape(double_tape_pointer) = OpenAD_Symbol_154
          double_tape_pointer = double_tape_pointer+1

C taping end
            our_rev_mode%arg_store=.FALSE.
            our_rev_mode%arg_restore=.FALSE.
            our_rev_mode%plain=.FALSE.
            our_rev_mode%tape=.FALSE.
            our_rev_mode%adjoint=.TRUE.
          end if 
          if (our_rev_mode%adjoint) then
C            print*, " adjoint    ", our_rev_mode
            our_rev_mode%arg_store=.FALSE.
            our_rev_mode%arg_restore=.TRUE.
            our_rev_mode%plain=.FALSE.
            our_rev_mode%tape=.TRUE.
            our_rev_mode%adjoint=.FALSE.
C adjoint
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_185 = double_tape(double_tape_pointer)
          G%d = G%d+H_OBJ7%d
          F%d = F%d+H_OBJ7%d
          H_OBJ7%d = 0.0d0
          F%d = F%d-H_OBJ9%d
          G%d = G%d+H_OBJ9%d
          H_OBJ9%d = 0.0d0
          OpenAD_Symbol_184%d = OpenAD_Symbol_184%d+F%d*(OpenAD_Symbol_1
     +85)
          F%d = 0.0d0
          R12%d = R12%d-OpenAD_Symbol_184%d
          R03%d = R03%d+OpenAD_Symbol_184%d
          OpenAD_Symbol_184%d = 0.0d0
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_186 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_187 = double_tape(double_tape_pointer)
          OpenAD_Symbol_182%d = OpenAD_Symbol_182%d+H_OBJ6%d
          F%d = F%d+H_OBJ6%d
          H_OBJ6%d = 0.0d0
          F%d = F%d-H_OBJ10%d
          OpenAD_Symbol_182%d = OpenAD_Symbol_182%d+H_OBJ10%d
          H_OBJ10%d = 0.0d0
          OpenAD_Symbol_183%d = OpenAD_Symbol_183%d+F%d*(OpenAD_Symbol_1
     +86)
          F%d = 0.0d0
          R02%d = R02%d+G%d*(OpenAD_Symbol_187)
          G%d = 0.0d0
          R12%d = R12%d+OpenAD_Symbol_183%d
          R03%d = R03%d+OpenAD_Symbol_183%d
          OpenAD_Symbol_183%d = 0.0d0
          G%d = G%d+OpenAD_Symbol_182%d
          OpenAD_Symbol_182%d = 0.0d0
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_188 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_189 = double_tape(double_tape_pointer)
          R02%d = R02%d+G%d*(OpenAD_Symbol_188)
          G%d = 0.0d0
          R13%d = R13%d+H_OBJ14%d*(1.2D+01)
          H_OBJ14%d = 0.0d0
          OpenAD_Symbol_181%d = OpenAD_Symbol_181%d+H_OBJ13%d
          F%d = F%d+H_OBJ13%d
          H_OBJ13%d = 0.0d0
          F%d = F%d-H_OBJ12%d
          OpenAD_Symbol_181%d = OpenAD_Symbol_181%d+H_OBJ12%d
          H_OBJ12%d = 0.0d0
          R12%d = R12%d+F%d*(OpenAD_Symbol_189)
          F%d = 0.0d0
          G%d = G%d+OpenAD_Symbol_181%d
          OpenAD_Symbol_181%d = 0.0d0
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_190 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_191 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_192 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_193 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_194 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_195 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_196 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_197 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_198 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_199 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_200 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_201 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_202 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_203 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_204 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_205 = double_tape(double_tape_pointer)
          G%d = G%d+H_OBJ11%d
          F%d = F%d+H_OBJ11%d
          H_OBJ11%d = 0.0d0
          F%d = F%d-H_OBJ8%d
          G%d = G%d+H_OBJ8%d
          H_OBJ8%d = 0.0d0
          R13%d = R13%d+G%d*(OpenAD_Symbol_190)
          G%d = 0.0d0
          R03%d = R03%d+F%d*(OpenAD_Symbol_191)
          F%d = 0.0d0
          M12%d = M12%d+R12%d*(OpenAD_Symbol_192)
          GG%d = GG%d+R12%d*(OpenAD_Symbol_193)
          LOC2%d = LOC2%d+R12%d*(OpenAD_Symbol_194)
          D12%d = D12%d+R12%d*(OpenAD_Symbol_195)
          R12%d = 0.0d0
          M03%d = M03%d+R03%d*(OpenAD_Symbol_196)
          GG%d = GG%d+R03%d*(OpenAD_Symbol_197)
          LOC2%d = LOC2%d+R03%d*(OpenAD_Symbol_198)
          D03%d = D03%d+R03%d*(OpenAD_Symbol_199)
          R03%d = 0.0d0
          M13%d = M13%d+R02%d*(OpenAD_Symbol_200)
          GG%d = GG%d+R02%d*(OpenAD_Symbol_201)
          LOC1%d = LOC1%d+R02%d
          R02%d = 0.0d0
          M02%d = M02%d+R13%d*(OpenAD_Symbol_202)
          GG%d = GG%d+R13%d*(OpenAD_Symbol_203)
          LOC1%d = LOC1%d+R13%d
          R13%d = 0.0d0
          OpenAD_Symbol_180%d = OpenAD_Symbol_180%d+LOC1%d*(OpenAD_Symbo
     +l_204)
          LOC2%d = LOC2%d+LOC1%d*(OpenAD_Symbol_205)
          LOC1%d = 0.0d0
          M23%d = M23%d+OpenAD_Symbol_180%d
          M01%d = M01%d+OpenAD_Symbol_180%d
          OpenAD_Symbol_180%d = 0.0d0
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_206 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_207 = double_tape(double_tape_pointer)
          LOC1%d = LOC1%d+H_OBJ19%d
          F%d = F%d+H_OBJ19%d
          H_OBJ19%d = 0.0d0
          F%d = F%d-H_OBJ17%d
          LOC1%d = LOC1%d+H_OBJ17%d
          H_OBJ17%d = 0.0d0
          R00%d = R00%d+LOC1%d*(OpenAD_Symbol_206)
          LOC1%d = 0.0d0
          R00%d = R00%d+H_OBJ20%d*(OpenAD_Symbol_207)
          H_OBJ20%d = 0.0d0
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_208 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_209 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_210 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_211 = double_tape(double_tape_pointer)
          F%d = F%d-H_OBJ18%d
          G%d = G%d+H_OBJ18%d
          H_OBJ18%d = 0.0d0
          G%d = G%d+H_OBJ15%d
          F%d = F%d+H_OBJ15%d
          H_OBJ15%d = 0.0d0
          OpenAD_Symbol_177%d = OpenAD_Symbol_177%d+F%d*(OpenAD_Symbol_2
     +08)
          F%d = 0.0d0
          M01%d = M01%d+OpenAD_Symbol_177%d*(OpenAD_Symbol_209)
          GG%d = GG%d+OpenAD_Symbol_177%d*(OpenAD_Symbol_210)
          D01%d = D01%d+OpenAD_Symbol_177%d
          OpenAD_Symbol_177%d = 0.0d0
          R11%d = R11%d-H_OBJ16%d
          LOC1%d = LOC1%d+H_OBJ16%d
          H_OBJ16%d = 0.0d0
          R11%d = R11%d+G%d
          LOC1%d = LOC1%d+G%d
          G%d = 0.0d0
          R00%d = R00%d+LOC1%d*(OpenAD_Symbol_211)
          LOC1%d = 0.0d0
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_212 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_213 = double_tape(double_tape_pointer)
          LOC1%d = LOC1%d+H_OBJ4%d
          F%d = F%d+H_OBJ4%d
          H_OBJ4%d = 0.0d0
          F%d = F%d-H_OBJ2%d
          LOC1%d = LOC1%d+H_OBJ2%d
          H_OBJ2%d = 0.0d0
          R11%d = R11%d+LOC1%d*(OpenAD_Symbol_212)
          LOC1%d = 0.0d0
          R11%d = R11%d+H_OBJ5%d*(OpenAD_Symbol_213)
          H_OBJ5%d = 0.0d0
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_214 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_215 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_216 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_217 = double_tape(double_tape_pointer)
          F%d = F%d-H_OBJ3%d
          G%d = G%d+H_OBJ3%d
          H_OBJ3%d = 0.0d0
          G%d = G%d+H_OBJ0%d
          F%d = F%d+H_OBJ0%d
          H_OBJ0%d = 0.0d0
          OpenAD_Symbol_175%d = OpenAD_Symbol_175%d+F%d*(OpenAD_Symbol_2
     +14)
          F%d = 0.0d0
          M23%d = M23%d+OpenAD_Symbol_175%d*(OpenAD_Symbol_215)
          GG%d = GG%d+OpenAD_Symbol_175%d*(OpenAD_Symbol_216)
          D01%d = D01%d+OpenAD_Symbol_175%d
          OpenAD_Symbol_175%d = 0.0d0
          R00%d = R00%d-H_OBJ1%d
          LOC1%d = LOC1%d+H_OBJ1%d
          H_OBJ1%d = 0.0d0
          R00%d = R00%d+G%d
          LOC1%d = LOC1%d+G%d
          G%d = 0.0d0
          R11%d = R11%d+LOC1%d*(OpenAD_Symbol_217)
          LOC1%d = 0.0d0
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_218 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_219 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_220 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_221 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_222 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_223 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_224 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_225 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_226 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_227 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_228 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_229 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_230 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_231 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_232 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_233 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_234 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_235 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_236 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_237 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_238 = double_tape(double_tape_pointer)
          OpenAD_Symbol_174%d = OpenAD_Symbol_174%d+D01%d*(OpenAD_Symbol
     +_218)
          LOC2%d = LOC2%d+D01%d*(OpenAD_Symbol_219)
          D01%d = 0.0d0
          M22%d = M22%d+R11%d*(OpenAD_Symbol_220)
          GG%d = GG%d+R11%d*(OpenAD_Symbol_221)
          LOC2%d = LOC2%d+R11%d*(OpenAD_Symbol_222)
          D11%d = D11%d+R11%d*(OpenAD_Symbol_223)
          R11%d = 0.0d0
          M33%d = M33%d+R00%d*(OpenAD_Symbol_224)
          GG%d = GG%d+R00%d*(OpenAD_Symbol_225)
          LOC2%d = LOC2%d+R00%d*(OpenAD_Symbol_226)
          D00%d = D00%d+R00%d*(OpenAD_Symbol_227)
          R00%d = 0.0d0
          LOC1%d = LOC1%d-G_OBJ3%d
          ADJ_M2%d = ADJ_M2%d-G_OBJ3%d
          G_OBJ3%d = 0.0d0
          M13%d = M13%d+OpenAD_Symbol_174%d
          M02%d = M02%d+OpenAD_Symbol_174%d
          OpenAD_Symbol_174%d = 0.0d0
          MATR3%d = MATR3%d+M23%d*(OpenAD_Symbol_228)
          MATR2%d = MATR2%d+M23%d*(OpenAD_Symbol_229)
          M23%d = 0.0d0
          MATR3%d = MATR3%d+M13%d*(OpenAD_Symbol_230)
          MATR1%d = MATR1%d+M13%d*(OpenAD_Symbol_231)
          M13%d = 0.0d0
          MATR2%d = MATR2%d+M12%d*(OpenAD_Symbol_232)
          MATR1%d = MATR1%d+M12%d*(OpenAD_Symbol_233)
          M12%d = 0.0d0
          MATR2%d = MATR2%d+M02%d*(OpenAD_Symbol_234)
          MATR0%d = MATR0%d+M02%d*(OpenAD_Symbol_235)
          M02%d = 0.0d0
          MATR1%d = MATR1%d+M01%d*(OpenAD_Symbol_236)
          MATR0%d = MATR0%d+M01%d*(OpenAD_Symbol_237)
          M01%d = 0.0d0
          OpenAD_Symbol_173%d = OpenAD_Symbol_173%d+LOC2%d*(2.0D00)
          LOC2%d = 0.0d0
          LOC1%d = LOC1%d+G_OBJ5%d*(2.0D00)
          G_OBJ5%d = 0.0d0
          LOC1%d = LOC1%d-G_OBJ4%d
          ADJ_M2%d = ADJ_M2%d+G_OBJ4%d
          G_OBJ4%d = 0.0d0
          ADJ_M3%d = ADJ_M3%d+LOC1%d*(OpenAD_Symbol_238)
          LOC1%d = 0.0d0
          LOC2%d = LOC2%d+OpenAD_Symbol_173%d
          OpenAD_Symbol_173%d = 0.0d0
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_239 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_240 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_241 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_242 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_243 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_244 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_245 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_246 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_247 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_248 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_249 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_250 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_251 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_252 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_253 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_254 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_255 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_256 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_257 = double_tape(double_tape_pointer)
          LOC1%d = LOC1%d-G_OBJ0%d
          ADJ_M0%d = ADJ_M0%d-G_OBJ0%d
          G_OBJ0%d = 0.0d0
          LOC1%d = LOC1%d+G_OBJ2%d*(2.0D00)
          G_OBJ2%d = 0.0d0
          LOC1%d = LOC1%d-G_OBJ1%d
          ADJ_M0%d = ADJ_M0%d+G_OBJ1%d
          G_OBJ1%d = 0.0d0
          ADJ_M1%d = ADJ_M1%d+LOC1%d*(OpenAD_Symbol_239)
          LOC1%d = 0.0d0
          MATR0%d = MATR0%d+ADJ_M3%d*(OpenAD_Symbol_240)
          G%d = G%d+ADJ_M3%d*(OpenAD_Symbol_241)
          OpenAD_Symbol_172%d = OpenAD_Symbol_172%d+ADJ_M3%d*(OpenAD_Sym
     +bol_242)
          MATR3%d = MATR3%d+ADJ_M3%d*(OpenAD_Symbol_243)
          ADJ_M3%d = 0.0d0
          MATR1%d = MATR1%d+ADJ_M2%d*(OpenAD_Symbol_244)
          G%d = G%d+ADJ_M2%d*(OpenAD_Symbol_245)
          OpenAD_Symbol_172%d = OpenAD_Symbol_172%d+ADJ_M2%d*(OpenAD_Sym
     +bol_246)
          MATR2%d = MATR2%d+ADJ_M2%d*(OpenAD_Symbol_247)
          ADJ_M2%d = 0.0d0
          MATR2%d = MATR2%d+ADJ_M1%d*(OpenAD_Symbol_248)
          G%d = G%d+ADJ_M1%d*(OpenAD_Symbol_249)
          OpenAD_Symbol_172%d = OpenAD_Symbol_172%d+ADJ_M1%d*(OpenAD_Sym
     +bol_250)
          MATR1%d = MATR1%d+ADJ_M1%d*(OpenAD_Symbol_251)
          ADJ_M1%d = 0.0d0
          MATR3%d = MATR3%d+ADJ_M0%d*(OpenAD_Symbol_252)
          G%d = G%d+ADJ_M0%d*(OpenAD_Symbol_253)
          OpenAD_Symbol_172%d = OpenAD_Symbol_172%d+ADJ_M0%d*(OpenAD_Sym
     +bol_254)
          MATR0%d = MATR0%d+ADJ_M0%d*(OpenAD_Symbol_255)
          ADJ_M0%d = 0.0d0
          LOC2%d = LOC2%d+G%d*(OpenAD_Symbol_256)
          F%d = F%d+G%d*(OpenAD_Symbol_257)
          G%d = 0.0d0
          LOC1%d = LOC1%d+OpenAD_Symbol_172%d
          OpenAD_Symbol_172%d = 0.0d0
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_258 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_259 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_260 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_261 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_262 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_263 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_264 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_265 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_266 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_267 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_268 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_269 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_270 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_271 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_272 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_273 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_274 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_275 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_276 = double_tape(double_tape_pointer)
          G%d = G%d+GG%d*(OpenAD_Symbol_258)
          GG%d = 0.0d0
          G%d = G%d+LOC2%d*(OpenAD_Symbol_259)
          LOC2%d = 0.0d0
          LOC1%d = LOC1%d+OBJ%d*(OpenAD_Symbol_260)
          F%d = F%d+OBJ%d*(OpenAD_Symbol_261)
          OBJ%d = 0.0d0
          G%d = G%d+LOC1%d*(OpenAD_Symbol_262)
          LOC1%d = 0.0d0
          D12%d = D12%d+F%d
          D03%d = D03%d+F%d
          F%d = 0.0d0
          M22%d = M22%d+D03%d*(OpenAD_Symbol_263)
          M11%d = M11%d+D03%d*(OpenAD_Symbol_264)
          D03%d = 0.0d0
          M33%d = M33%d+D12%d*(OpenAD_Symbol_265)
          M00%d = M00%d+D12%d*(OpenAD_Symbol_266)
          D12%d = 0.0d0
          MATR3%d = MATR3%d+M33%d*(OpenAD_Symbol_267)
          M33%d = 0.0d0
          MATR1%d = MATR1%d+M11%d*(OpenAD_Symbol_268)
          M11%d = 0.0d0
          M12%d = M12%d+D11%d*(2.0D00)
          D11%d = 0.0d0
          M03%d = M03%d+D00%d*(2.0D00)
          D00%d = 0.0d0
          M12%d = M12%d-G%d
          M03%d = M03%d+G%d
          G%d = 0.0d0
          MATR2%d = MATR2%d+M12%d*(OpenAD_Symbol_269)
          MATR1%d = MATR1%d+M12%d*(OpenAD_Symbol_270)
          M12%d = 0.0d0
          MATR3%d = MATR3%d+M03%d*(OpenAD_Symbol_271)
          MATR0%d = MATR0%d+M03%d*(OpenAD_Symbol_272)
          M03%d = 0.0d0
          OpenAD_Symbol_163%d = OpenAD_Symbol_163%d+MATR3%d*(OpenAD_Symb
     +ol_273)
          MATR3%d = 0.0d0
          OpenAD_Symbol_162%d = OpenAD_Symbol_162%d+MATR1%d*(OpenAD_Symb
     +ol_274)
          MATR1%d = 0.0d0
          X5%d = X5%d+OpenAD_Symbol_163%d*(2.0D00)
          X4%d = X4%d-OpenAD_Symbol_163%d
          X3%d = X3%d-OpenAD_Symbol_163%d
          OpenAD_Symbol_163%d = 0.0d0
          X2%d = X2%d+OpenAD_Symbol_162%d*(2.0D00)
          X1%d = X1%d-OpenAD_Symbol_162%d
          X0%d = X0%d-OpenAD_Symbol_162%d
          OpenAD_Symbol_162%d = 0.0d0
          MATR2%d = MATR2%d+M22%d*(OpenAD_Symbol_275)
          M22%d = 0.0d0
          MATR0%d = MATR0%d+M00%d*(OpenAD_Symbol_276)
          M00%d = 0.0d0
          X3%d = X3%d-MATR2%d
          X4%d = X4%d+MATR2%d
          MATR2%d = 0.0d0
          X0%d = X0%d-MATR0%d
          X1%d = X1%d+MATR0%d
          MATR0%d = 0.0d0

C adjoint end
            our_rev_mode%arg_store=.FALSE.
            our_rev_mode%arg_restore=.TRUE.
            our_rev_mode%plain=.FALSE.
            our_rev_mode%tape=.TRUE.
            our_rev_mode%adjoint=.FALSE.
          end if 
        end subroutine head
